// Demodul.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "Demodul.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CDemodul
CDemodul::CDemodul(short i,short o,long mod,short m,short l,short c)
{
	short rcode;
	short larg,haut,nbB;
	Ajoute("Oprations ralises:");
	mode=mod;
	//Pointeurs sur le document
	m_pApp=((CBkApp*)AfxGetApp());
	m_pIn=m_pApp->GetDocument(i);
	in=m_pIn->image;
	m_pOut=m_pApp->GetDocument(o);
	out=m_pOut->image;

	//Image temporaire 8 bits, utilise pour:
	//- dilatation
	//- erosion,...
	imt=m_pApp->imt[0];//Image temporaire n0
	larg=imt->endx-imt->stx+1;
	haut=imt->endy-imt->sty+1;
	nbB=imt->bmh->biBitCount;
	
	if (m_pIn->m_iL!=larg || m_pIn->m_iH!=haut || nbB!=8)
	{
		freeimage(imt);
		rcode=allocimage(imt,m_pIn->m_iL,m_pIn->m_iH,8);
		if (rcode!=0) 
		{
			Ajoute("Erreur rservation mmoire image imt");
			AfxMessageBox("Erreur rservation mmoire image imt !");
		}
		else
			Ajoute("Image imt n0 redimensionne");
	}
	else
		Ajoute("Image imt n0 conserve");
	//Conversion de l'image in en 8 bits
	if (m_pIn->image->bmh->biBitCount!=8)
	{
		Ajoute("Conversion de l'image  dmoduler en 8 bits");
		rcode=colortogray(m_pIn->image,imt);
		if (rcode!=0) Ajoute ("Erreur de conversion en 8 bits !");
		freeimage(m_pIn->image);
		rcode=allocimage(m_pIn->image,m_pIn->m_iL,m_pIn->m_iH,8);
		if (rcode!=0)
		{ 
			AfxMessageBox("Erreur rservation mmoire image In !");
			Ajoute ("Erreur rservation mmoire image In !");
		}
		if (rcode==0) copyimage(imt,m_pIn->image);
		m_pIn->m_iNbB=8;
	}
	if (!(mode&2))
	{
		//Image correction non demande, on prend la temporaire
		correction=m_pApp->imt[1];//Image temporaire n1
		larg=correction->endx-correction->stx+1;
		haut=correction->endy-correction->sty+1;

		//CString z;z.Format("%d,%d",larg,haut);AfxMessageBox(z);

		nbB=correction->bmh->biBitCount;
		if (m_pIn->m_iL!=larg || m_pIn->m_iH!=haut || nbB!=8)
		{
			freeimage(correction);
			rcode=allocimage(correction,m_pIn->m_iL,m_pIn->m_iH,8);
			if (rcode!=0)
			{ 
				Ajoute("Erreur rservation mmoire image ordre des franges");
				AfxMessageBox("Erreur rservation mmoire image ordre des franges !");
			}
			else
				Ajoute("Image correction (ordre des franges) n1 redimensionne");
		}
		else
			Ajoute("Image correction (ordre des franges) n1 conserve");
	}
	else
	{
		m_pCorrection=m_pApp->GetDocument(c);
		correction=m_pCorrection->image;
	}
	if (!(mode&128))
	{
		//Image label non demande, on prend la temporaire
		labl=m_pApp->imt[2];//Temporaire n2
		larg=labl->endx-labl->stx+1;
		haut=labl->endy-labl->sty+1;
		nbB=labl->bmh->biBitCount;
		if (m_pIn->m_iL!=larg || m_pIn->m_iH!=haut || nbB!=24)
		{
			freeimage(labl);
			rcode=allocimage(labl,m_pIn->m_iL,m_pIn->m_iH,24);
			if (rcode!=0)
			{
				Ajoute("Erreur rservation mmoire image label");
				AfxMessageBox("Erreur rservation mmoire image label !");
			}
			else
				Ajoute("Image tempo. label n2 redimensionne");
		}
		else
		 Ajoute("Image tempo label n2 conserve");
	}
	else
	{
		m_pLabel=m_pApp->GetDocument(l);
		labl=m_pLabel->image;
	}
	//Masque
	m_pMasque=m_pApp->GetDocument(m);
	mask=m_pMasque->image;

	//Image brouillon
	brouillon=m_pApp->imt[3];//Temporaire n3
	larg=brouillon->endx-brouillon->stx+1;
	haut=brouillon->endy-brouillon->sty+1;
	nbB=brouillon->bmh->biBitCount;
	if (m_pIn->m_iL!=larg || m_pIn->m_iH!=haut || nbB!=24)
	{
		freeimage(brouillon);
		rcode=allocimage(brouillon,m_pIn->m_iL,m_pIn->m_iH,24);
		if (rcode!=0) 
		{
			Ajoute("Erreur rservation mmoire image brouillon");
			AfxMessageBox("Erreur rservation mmoire image brouillon !");
		}
		else
			Ajoute("Image brouillon n3 redimensionne");
	}
	else
		Ajoute("Image brouillon n3 conserve");
}
//________________________________________
CDemodul::~CDemodul()
{
	m_pOut->UpdateAllViews(NULL);
	if (!(mode&2))
	{
	}
	else
	{
		m_pCorrection->UpdateAllViews(NULL);
	}
	if (!(mode&128))
	{
	}
	else
	{
		m_pLabel->UpdateAllViews(NULL);
	}
	Ajoute("Fin de la dmodulation");
}
//________________________________________
BEGIN_MESSAGE_MAP(CDemodul,CWnd)
	//{{AFX_MSG_MAP(CDemodul)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CDemodul message handlers
void CDemodul::IpBoolimg(imgdes* nfi1,imgdes* nfi2,imgdes* nfo,long mode)
{
	//Fonctions logiques
	short i,j;
	long w,w1;
	switch (mode)
	{
		case V_AND:
			for (i=nfi1->stx;i<=nfi1->endx;i++)
			{
				for (j=nfi1->sty;j<=nfi1->endy;j++)
				{
					w=getpixelcolor(nfi1,i,j);
					w1=getpixelcolor(nfi2,i,j);
					if (w1==w1)
						setpixelcolor(nfo,i,j,w1);
					else
						setpixelcolor(nfo,i,j,0);
				}
			}
		break;
	}
}
//________________________________________
void CDemodul::IpBoolVal(imgdes* nfi,long cste,imgdes* nfo,long mode)
{
	short i,j;
	long w,w1;
	//Fonctions logiques
	switch (mode)
	{
		case V_NOT:
			//Ici, je ne vois pas l'intrt de la constante
			//negative(nfi,nfo);
			for (i=nfi->stx;i<=nfi->endx;i++)
			{
				for (j=nfi->sty;j<=nfi->endy;j++)
				{
					w=getpixelcolor(nfi,i,j);
					setpixelcolor(nfo,i,j,255-w);
				}
			}
		break;
	}
}
//________________________________________
void CDemodul::IpAritval(imgdes* nfi,double cste,imgdes* nfo,long mode)
{
	//Addition, soustraction, ... d'un nombre  une image
	short i,j;
	long w,w1;
	switch (mode)
	{
		case V_ADD:
			
			for (i=nfi->stx;i<=nfi->endx;i++)
			{
				for (j=nfi->sty;j<=nfi->endy;j++)
				{
					w=getpixelcolor(nfi,i,j);
					w1=w+cste;
					setpixelcolor(nfo,i,j,w1);
				}
			}
		break;
		case V_SUB:
			for (i=nfi->stx;i<=nfi->endx;i++)
			{
				for (j=nfi->sty;j<=nfi->endy;j++)
				{
					w=getpixelcolor(nfi,i,j);
					w1=w-cste;
					if (w1<0) w1=0;
					setpixelcolor(nfo,i,j,w1);
				}
			}
		break;
		case V_MUL:
			if (cste<0) cste=-cste;
			for (i=nfi->stx;i<=nfi->endx;i++)
			{
				for (j=nfi->sty;j<=nfi->endy;j++)
				{
					w=getpixelcolor(nfi,i,j);
					w1=w*cste;
					setpixelcolor(nfo,i,j,w1);
				}
			}
		break;
	}
}
//________________________________________
void CDemodul::IpAritimg(imgdes* nfi1,imgdes* nfi2,imgdes* nfo,const long mode)
{
	//Addition, soustraction, ... entre deux images
	short i,j;
	long w;
	switch (mode)
	{
		case V_ADD:
			for (i=nfi1->stx;i<=nfi1->endx;i++)
			{
				for (j=nfi1->sty;j<=nfi1->endy;j++)
				{
					w=getpixelcolor(nfi1,i,j)+getpixelcolor(nfi2,i,j);
					setpixelcolor(nfo,i,j,w);
				}
			}
		break;
	}
}
//________________________________________
void CDemodul::IpAbs(imgdes* nfi,imgdes* nfo)
{
	//Valeur absolue
	AfxMessageBox("Fonction non crite...");
}
//________________________________________
void CDemodul::IpDilate(imgdes* nfi,imgdes* nfo,long size)
{
	//Dilatation, voir page 107
	short 
		nb,i,j,i1,j1;
	long w,wmax;

	int rcode;
	for (nb=0;nb<size;nb++)
	{
		//Image temporaire imt dfinie dans constructeur
		for (i=nfi->stx+1;i<=nfi->endx-1;i=i++)
		{
			for (j=nfi->sty+1;j<=nfi->endy-1;j++)
			{
				wmax=getpixelcolor(nfi,i,j);
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(nfi,i1,j1);
						if (w>wmax) wmax=w;
					}
				}
				//Affectation de la zone avec wmax
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(imt,i1,j1);
						if (wmax>w) setpixelcolor(imt,i1,j1,wmax);
					}
				}
			}
		}
		copyimage(imt,nfo);
	}
}
//________________________________________
void CDemodul::IpErode(imgdes* nfi,imgdes* nfo,long size)
{
	//Erosion, voir page 108
	short 
		nb,i,j,i1,j1;
	long w,wmin;

	int rcode;
	for (nb=0;nb<size;nb++)
	{
		//Image temporaire imt dfinie dans constructeur
		for (i=nfi->stx+1;i<=nfi->endx-1;i=i++)
		{
			for (j=nfi->sty+1;j<=nfi->endy-1;j++)
			{
				wmin=getpixelcolor(nfi,i,j);
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(nfi,i1,j1);
						if (w<wmin) wmin=w;
					}
				}
				//Affectation de la zone avec wmax
				for (i1=i-1;i1<=i+1;i1++)
				{
					for (j1=j-1;j1<=j+1;j1++)
					{
						w=getpixelcolor(imt,i1,j1);
						if (wmin<w) setpixelcolor(imt,i1,j1,wmin);
					}
				}
			}
		}
		copyimage(imt,nfo);
	}
}
//________________________________________
void CDemodul::IpMask(imgdes* nfi,imgdes* nfm,imgdes* nfo)
{
	short i,j;
	long w,w1;
	//Masquage
	for (i=nfi->stx;i<=nfi->endx;i++)
	{
		for (j=nfi->sty;j<=nfi->endy;j++)
		{
			w=getpixelcolor(nfi,i,j);
			w1=getpixelcolor(nfm,i,j);
			if (w1>0)
				setpixelcolor(nfo,i,j,w);
			else
				setpixelcolor(nfo,i,j,0);
		}
	}
}
//________________________________________
void CDemodul::IpAnam(imgdes* nfi,imgdes* nfo,long *ival,long *array,long low,long high)
{
	//Anamorphose, voir page 106
	short i,j;
	long w,w1;
	for (i=nfi->stx;i<=nfi->endx;i++)
	{
		for (j=nfi->sty;j<=nfi->endy;j++)
		{
			w=getpixelcolor(nfi,i,j);
			if (w>=ival[0] && w<=ival[1])
			{
				w1=array[w-ival[0]];
				if (w1<low) w1=low;
				if (w1>high) w1=high;
				setpixelcolor(nfo,i,j,w1);
			}
			else
				setpixelcolor(nfo,i,j,0);
		}
	}
}
//________________________________________
void CDemodul::IpThr(imgdes* nfi,imgdes* nfo,float* level,float* value,long option)
{
	//Seuillage, voir page 107
	short i,j;
	long w,w1,w2;
	switch (option)
	{
		case V_BIN:
			w1=(long)level[0];
			w2=(long)level[1];
			for (i=nfi->stx;i<=nfi->endx;i++)
			{
				for (j=nfi->sty;j<=nfi->endy;j++)
				{
					w=getpixelcolor(nfi,i,j);
					if (w>=w1 && w<=w2)
						setpixelcolor(nfo,i,j,255);
					else
						setpixelcolor(nfo,i,j,0);
				}
			}
			//Pour une image binaire, value n'a pas d'importance
			value[0]=0;value[1]=255;value[2]=255;
		break;
	}
}
//________________________________________
void CDemodul::IpRecon(imgdes* nfi1,imgdes* nfi2,imgdes* nfo)
{
	//Reconstruction, voir page 109
	//Attention, les images doivent tre seuilles !!!
	//nfi1: image source, nfi2: image avec marqueurs, nfo: image rsultante
	imgdes im;
	BOOL ok;
	short
		nb,
		l=nfi2->endx-nfi2->stx+1,
		h=nfi2->endy-nfi2->sty+1;
	
	int rcode;
	if (nfi2->colors==2)
	 rcode=allocimage(&im,l,h,1);
	else
	if (nfi2->colors==256)
	 rcode=allocimage(&im,l,h,8);
	else
	 rcode=allocimage(&im,l,h,24);

	if (rcode!=0) AfxMessageBox("Erreur rservation mmoire image im !");

	//Image originale avec marqueurs
	if (rcode==0) rcode=copyimage(nfi2,&im);
	if (rcode==0)
	{
		nb=0;
		do
		{
			//0. Copie de l'image originale avec marqueur (nfi2, image marqueur avant dilatation)
			rcode=copyimage(nfi2,nfo);
			//1. Dilation de l'image avec marqueur (im, image aprs dilatation)
			IpDilate(nfi2,nfi2,1);
			//2. ET logique entre cette image dilate et l'image  reconstruire
			//if (rcode==0) rcode=andimage(nfi2,nfi1,nfi2);
			IpBoolimg(nfi2,nfi1,nfi2,V_AND);
			//3. On compare cette image  l'image avant dilatation
			ok=IpCompare(nfo,nfi2);

			nb++;
		}
		while (rcode==0 && nb<60 && (!ok));
		//On garde l'image marqueur originale
		if (rcode==0) rcode=copyimage(&im,nfi2);
		//4. Suppression image
		freeimage(&im);
	}
	else
		AfxMessageBox("Erreur rservation mmoire fonction IpRecon");
}
//________________________________________
BOOL CDemodul::IpCompare(imgdes* nfi1,imgdes* nfi2)
{
	//Comparaison de l'image nfi1 et de l'image nfi2
	long w1,w2;
	BOOL ok=TRUE;
	short
		i,j,
		l=nfi1->endx-nfi1->stx+1,
		h=nfi1->endy-nfi1->sty+1;

	i=nfi1->stx;

	while(i<=nfi1->endx && ok)
	{
		j=nfi1->sty;
		while(j<=nfi1->endy && ok)
		{
			w1=getpixelcolor(nfi1,i,j);
			w2=getpixelcolor(nfi2,i,j);
			if (w1!=w2) ok=FALSE;
			j++;
		}
		i++;
	}
	return ok;
}
//________________________________________
void CDemodul::IpHisto(imgdes* nfi,long low,long high,long* tlow,long* thigh,long* tab)
{
	//Histogramme d'une image, voir page 110
	short i,j,w;
	*tlow=5000;
	*thigh=-5000;
	
	for (i=0;i<3561;i++) tab[i]=0; //Voir page 115, dclaration 3561...
	//for (i=0;i<256;i++) tab[i]=0;
	for (i=nfi->stx;i<=nfi->endx;i++)
	{
		for (j=nfi->sty;j<=nfi->endy;j++)
		{
			w=getpixelcolor(nfi,i,j);
			//if (w>=0 && w<256 && w>=low && w<=high) tab[w]++;
			if (w>=0 && w<3561 && w>=low && w<=high) 
			{
				tab[w]++;
				if (w<*tlow) *tlow=w;
				if (w>*thigh) *thigh=w;
			}
		}
	}
}
//Signe___________________________________
short CDemodul::signe(short a)
{
	if (a>0) return 1; else return -1;
}
//________________________________________
//Recherche du premier point d'intensit nulle au voisinage de x et y
int CDemodul::recherche(imgdes *im,short *x,short *y)
{
	long pixel;
	short yy;
	(*x)--;
	pixel=1;
	while(pixel!=0 && (*x)<im->endx*9/10)
	{
		(*x)++;
		yy=(*y);
		while (pixel!=0 && (yy<im->endy*9/10))
		{
			yy++;
			pixel=getpixelcolor(im,*x,yy);
		}
	}
	(*y)=yy;
	if (*x>=im->endx*9/10 && yy>=im->endy*9/10)
		return 0;
	else
		return 1;
}
//________________________________________
void CDemodul::ajoute(int leq)
{
	struct
	{
		short x,y;
	}
	reg[9],res[9];
	long x,y,i,j,k,m,n,aie,p;
	long pixel,pix1,pix2;
	CString s;
	//N du point dans la file
	p=file[leq];
	//Coordonnes du pixel dans la file
	x=f[leq][p].x;
	y=f[leq][p].y;
	//Ote le point de la file
	file[leq]++;

	//Dewrappe le point par rapport  ses voisins
	//Intensit du point courant  raccorder
	pix1=getpixelcolor(in,x,y);
	n=0;
	m=0;
	k=0;
	aie=0;
	//On analyse les points voisins du point (x,y)  raccorder, et le point courant
	for (i=-1;i<=1;i++)
	{
		for (j=-1;j<=1;j++)
		{
			//L'image ordre des franges (correction) est mise  255 pour tous les pixels par dfaut...
			pixel=getpixelcolor(correction,x+i,y+j);
			if (pixel!=255)
			{
				//Il y a un ordre de frange pour ce pixel
				//Le point a dj t raccord
				pix2=getpixelcolor(in,x+i,y+j);
				//res[n].x=pixel+(((res[n].y=abs(pix2-pix1))<128)?0:(short)signe(pix2-pix1));
				//Diffrence de phase entre les deux points
				res[n].y=abs(pix2-pix1);
				//Calcul de l'odre des franges
				if (res[n].y<128)
				{
					res[n].x=pixel;
				}
				else
				{
					res[n].x=pixel+signe(pix2-pix1);
				}
				//Les avis sont partags
				if (res[n].x!=res[0].x) aie=1;
				n++;
			}
			else
			{
				//Le point n'est pas encore raccord. Est-il dans la file ?
				//On cherche sa valeur dans l'image de la fonction de mrite [0, 20]
				pix2=getpixelcolor(labl,x+i,y+j);
				if (pix2<=50)
				{
					//Non, on le rajoute dans la file pix2
					p=file_fin[pix2];
					if (p<0 || p>=repartition[pix2])
					{
						s.Format("Dbordement file n%d: %d/%d",pix2,p,repartition[pix2]);
						AfxMessageBox(s);
						Ajoute(s);
					}
					f[pix2][p].x=x+i;
					f[pix2][p].y=y+j;
					file_fin[pix2]++;
					//Le pixel a t mis dans la file...
					setpixelcolor(labl,x+i,y+j,255+n_zone);//short n_zone, variable globale
				}
			}
		}
	}
	//Sont-ils tous d'accord ?
	if (aie==1)
	{
		//Si non, on prend la majorit pondr par son degr de certitude
		for (i=0;i<n;i++)
		{
			for (j=0;j<k;j++)
			{
				if (reg[j].x==res[i].x)
				{
					reg[j].y+=abs(res[i].y-128)+1;
					break;
				}
			}
			if (j==k)
			{
				reg[k].x=res[i].x;
				reg[k++].y=abs(res[i].y-128)+1;
			}
		}

		for (i=0;i<k;i++)
		{
			if (reg[i].y>m)
			{
				pix2=reg[i].x;
				m=reg[i].y;	
			}
		}
		if (pix2<0 || pix2>254)
		{
			s.Format("Ordre de frange dpass en file n%d: %d",leq,pix2);
			Ajoute(s);
			setpixelcolor(correction,x,y,254);				
		}
		else
			setpixelcolor(correction,x,y,pix2);				
	}
	else
	{
		//Tous les points ont le mme ordre de frange...
		if (res[0].x<0 || res[0].x>254)
		{
			s.Format("Ordre de frange dpass en file n%d: %d",leq,res[0].x);
			Ajoute(s);
			setpixelcolor(correction,x,y,254);				
		}
		else
		{
			//Tous les pixels ont le mme ordre de franges
			setpixelcolor(correction,x,y,res[0].x);				
		}
	}
}
//Unwrapping du pt________________________
//Valeur de b la plus proche de a module 256
short CDemodul::unw(short a,short b)
{
	if (abs(a-b)>127)
		return b+256*signe(a-b);
	else
		return b;
}
//Valeur abs de a-b_______________________
short CDemodul::hum(short a,short b)
{
	return abs(a-b);
}
//Saut de phase___________________________
//0: pas de saut, -1 s'il faut retrancher 127, 1 s'il faut ajouter 127
short CDemodul::d(short a,short b)
{
	if (abs(a-b)>127)
		return signe(a-b);
	else
		return 0;
}
//________________________________________
//Valeur absolue de la diffrence entre 2 pts localement raccords
short CDemodul::diff(short a,short b)
{
	if (abs(a-b)>128)
		return abs(256-abs(a-b));
	else
		return abs(a-b);
}
//________________________________________
//Initialisation de tous les pixels d'une image
void CDemodul::ZeroImage(long w,imgdes* nfi)
{
	short i,j;
	for (i=nfi->stx;i<=nfi->endx;i++)
	{
		for (j=nfi->sty;j<=nfi->endy;j++)
		{
			setpixelcolor(nfi,i,j,w);
		}
	}
}
//________________________________________
void CDemodul::Ajoute(CString s) 
{
	m_liste.Add(s);
}
//Ecriture pixels sur une ligne___________
short CDemodul::WriteRow(imgdes *im,short no,short *T)
{
	//CString s;
	short 
		err,i,k=0;

	if(no>=im->sty && no<=im->endy)
	{
		err=0;
		for (i=im->stx;i<=im->endx;i++)
		{
			setpixelcolor(im,i,no,T[k]);
			k++;
		}
	}
	else
		err=-1;
	return err;
}
//Lecture des pixels d'une ligne__________
short CDemodul::ReadRow(imgdes *im,short no,short *T)
{
	short 
		err,i,k=0;

	if(no>=im->sty && no<=im->endy)
	{
		err=0;
		for (i=im->stx;i<im->endx;i++)
		{
			T[k]=getpixelcolor(im,i,no);
			k++;
		}
	}
	else
		err=-1;
	return err;
}
//Ecriture pixels sur une ligne___________
short CDemodul::WriteColumn(imgdes *im,short no,short *T)
{
	short 
		err,i,k=0;

	if(no>=im->stx && no<=im->endx)
	{
		err=0;
		for (i=im->sty;i<=im->endy;i++)
		{
			setpixelcolor(im,no,i,T[k]);
			k++;
		}
	}
	else
		err=-1;
	return err;
}
//Fonctions de mrite (donnent une "qualit"  chaque point)
//1. Moindres carrs
int CDemodul::smincarre(imgdes *in,imgdes *out)
{
	long wmin=65000,wmax=-65000;
	short
		i,line,memo, 
		err=0,
		pix,
		*row1,*row2,*row3,*rowf,*ptr,
		*a1,*b1,*a2,*b2,*a3,*b3,*a4,*b4,*a5,*b5;

	//Nb.de pixels horizontaux
	pix=in->endx-in->stx+1;
	//Allocation dynamique colonnes
	rowf=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];
	a1=new short[pix];
	b1=new short[pix];
	a2=new short[pix];
	b2=new short[pix];
	a3=new short[pix];
	b3=new short[pix];
	a4=new short[pix];
	b4=new short[pix];
	a5=new short[pix];
	b5=new short[pix];

	for (i=0;i<pix;i++) rowf[i]=1024;
	//Initialisation valeurs en bordure
	err=WriteRow(out,out->sty,rowf);	
	err=WriteRow(out,out->sty+1,rowf);	
	err=WriteRow(out,out->sty+2,rowf);	
	err=WriteRow(out,out->endy,rowf);	
	err=WriteRow(out,out->endy-1,rowf);	
	err=WriteRow(out,out->endy-2,rowf);
	
	err=ReadRow(in,in->sty,row2);	
	err=ReadRow(in,in->sty+1,row3);
	err=ReadRow(in,in->sty+2,row1);
	
	for (line=in->sty+1;line<=in->endy;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=ptr;

		ptr=a1; a1=a2; a2=a3; a3=a4; a4=a5; a5=ptr;
		ptr=b1; b1=b2; b2=b3; b3=b4; b4=b5; b5=ptr;

		err=ReadRow(in,line+1,row3);
		//for (i=in->stx;i<pix;i++)
		for (i=in->stx+1;i<pix;i++)//Ajout +1
		{
			memo=row2[i];
			a5[i]=(unw(memo,row1[i+1])+unw(memo,row2[i+1])+unw(memo,row3[i+1])-unw(memo,row1[i-1])-unw(memo,row2[i-1])-unw(memo,row3[i-1]))/6;
			b5[i]=(unw(memo,row1[i-1])+unw(memo,row1[i+0])+unw(memo,row1[i+1])-unw(memo,row3[i-1])-unw(memo,row3[i-0])-unw(memo,row3[i+1]))/6;
			//if (i>in->stx+2 && i<pix-2 && line>in->sty+4)
			if (i>in->stx+2 && i<pix-2 && line>in->sty+5)
			{
				memo =hum(a1[i-2]+a1[i-1]+a1[i+0]+a1[i+1]+a1[i+2],a5[i+2]+a5[i+1]+a5[i+0]+a5[i-1]+a5[i-2]);				
				memo+=hum(a1[i-2]+a2[i-2]+a3[i-2]+a4[i-2],a5[i-2]+a1[i+2]+a2[i+2]+a3[i+2]+a4[i+2]+a5[i+2]);				
				memo+=hum(b1[i-2]+b1[i-1]+b1[i+0]+b1[i+1]+b1[i+2],b5[i+2]+b5[i+1]+b5[i+0]+b5[i-1]+b5[i-2]);				
				memo+=hum(b1[i-2]+b2[i-2]+b3[i-2]+b4[i-2],b5[i-2]+b1[i+2]+b2[i+2]+b3[i+2]+b4[i+2]+b5[i+2]);				
				memo+=hum(a3[i-2]+a1[i-0]+a2[i-2]+a1[i-2]+a2[i+0],a3[i+2]+a5[i+0]+a4[i+2]+a5[i+2]+a5[i+1]);				
				memo+=hum(a1[i+0]+a3[i+2]+a1[i+1]+a1[i+2]+a2[i+2],a5[i+0]+a3[i-2]+a5[i-1]+a5[i-2]+a4[i-2]);				
				memo+=hum(b3[i-2]+b1[i-0]+b2[i-2]+b1[i-2]+b2[i+0],b3[i+2]+b5[i+0]+b4[i+2]+b5[i+2]+b5[i+1]);				
				memo+=hum(b1[i+0]+b3[i+2]+b1[i+1]+b1[i+2]+b2[i+2],b5[i+0]+b3[i-2]+b5[i-1]+b5[i-2]+b4[i-2]);				
				if (memo>wmax) wmax=memo;
				if (memo<wmin) wmin=memo;
				//Ramen dans l'intervalle [0,1024]
				rowf[i-2]=(short)min(memo,1024);
				//rowf[i-2]=memo;
			}
		}
		//Ecriture image 
		//if (line>in->sty+4)
		if (line>in->sty+5)
		{
			err=WriteRow(out,line-2,rowf);
		}
	}		
	delete rowf;
	delete row1;
	delete row2;
	delete row3;
	delete a1;
	delete b1;
	delete a2;
	delete b2;
	delete a3;
	delete b3;
	delete a4;
	delete b4;
	delete a5;
	delete b5;
	CString s;
	s.Format("smincarre, w [%d, %d] ramen [0, 1024], err:%d",wmin,wmax,err);
	Ajoute(s);
	return err;
}
//2. Reprage des points foireux (dtection des discontinuits)
int CDemodul::sptsfoi(imgdes *in,imgdes *out)
{
	short
		i,line,memo, 
		err=0,
		pix,
		*row1,*row2,*rowf1,*rowf2,*ptr;
	
	pix=in->endx;
	row1=new short[pix];
	row2=new short[pix];
	rowf1=new short[pix];
	rowf2=new short[pix];

	err=ReadRow(in,in->sty,row2);
	for (line=in->sty;line<in->endy;line++)
	{
		ptr=row1;
		row1=row2;
		row2=ptr;
		ptr=rowf1;
		rowf1=rowf2;
		rowf2=ptr;
		err=ReadRow(in,line+1,row2);
		rowf1[0]=rowf2[0]=0;
		//for (i=in->stx;i<pix;i++)
		for (i=in->stx+1;i<pix;i++)//Ajout 1
		{
			memo=(short)256*abs(d(row1[i-1],row1[i])+d(row1[i],row2[i])+d(row2[i],row2[i-1])+d(row2[i-1],row1[i-1]));
			rowf1[i]+=memo;
			rowf1[i-1]+=memo;
			rowf2[i]=memo;
			//rowf2[i]+=memo;//Ajout +
			rowf2[i-1]+=memo;
		}
		err=WriteRow(out,line,rowf1);
	}
	err=WriteRow(out,line,rowf2);
	delete row1;
	delete row2;
	delete rowf1;
	delete rowf2;
	return err;
}
//3. Variance
//On prend la somme de la val. absolue des diffrences entre le point central et ses voisins localement raccords
int CDemodul::sunwvar(imgdes *in,imgdes *out)
{
	short 
		err=0,
		i,memo,
		*row1,*row2,*row3,*rowf,*ptr,
		pix;
	long line;

	pix=in->endx;
	rowf=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];
	pix--;
	err=ReadRow(in,in->sty,row2);
	err=ReadRow(in,in->sty+1,row3);
	rowf[0]=(diff(row2[0],row2[1])+diff(row2[0],row3[1])+diff(row2[0],row3[0]))*8/3;
	rowf[pix]=(diff(row2[pix],row2[pix-1])+diff(row2[pix],row3[pix-1])+diff(row2[pix],row3[pix]))*8/3;
	for (i=in->stx+1;i<pix;i++)//Ajout 1
	{
		memo=row2[i];
		rowf[i]=(diff(memo,row2[i-1])+diff(memo,row2[i+1])+diff(memo,row3[i-1])+diff(memo,row3[i])+diff(memo,row3[i+1]))*8/5;
	}
	err=WriteRow(out,in->stx,rowf);
	for (line=in->stx+2;line<in->endx;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=ptr;
		err=ReadRow(in,line+1,row3);
		rowf[0]=(diff(row2[0],row2[1])+diff(row2[0],row1[1])+diff(row2[0],row3[1])+diff(row2[0],row1[0])+diff(row2[0],row3[0]))*8/5;
		rowf[pix]=(diff(row2[pix],row1[pix])+diff(row2[pix],row2[pix-1])+diff(row2[pix],row1[pix-1])+diff(row2[pix],row3[pix])+diff(row2[pix],row3[pix-1]))*8/5;
		for (i=in->stx+1;i<pix;i++)//Ajout 1
		{
			memo=row2[i];
			rowf[i]=diff(memo,row2[i-1])+diff(memo,row2[i+1])+diff(memo,row3[i-1])+diff(memo,row3[i])+diff(memo,row3[i+1])+diff(memo,row1[i-1])+diff(memo,row1[i])+diff(memo,row1[i+1]);
		}
		err=WriteRow(out,line,rowf);
	}
	rowf[0]=(diff(row3[0],row2[1])+diff(row3[0],row3[1])+diff(row3[0],row2[0]))*8/3;
	rowf[pix]=(diff(row3[pix],row2[pix-1])+diff(row3[pix],row3[pix-1])+diff(row3[pix],row2[pix]))*8/3;
	for (i=in->stx+1;i<pix;i++)//Ajout 1
	{
		memo=row3[i];
		rowf[i]=(diff(memo,row2[i-1])+diff(memo,row2[i+1])+diff(memo,row3[i-1])+diff(memo,row2[i])+diff(memo,row3[i+1]))*8/5;
	}
	err=WriteRow(out,line,rowf);
	delete row1;
	delete row2;
	delete row3;
	delete rowf;
	return err;
}
//4. Linarit
int CDemodul::sunlin(imgdes *in,imgdes *out)
{
	short 
		i,memo,line,
		*row1,*row2,*row3,*rowf,*ptr,
		pix,
		err=0;
	pix=in->endx;
	rowf=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];
	pix--;
	err=ReadRow(in,in->stx,row2);
	err=ReadRow(in,in->stx+1,row3);

	rowf[0]=abs(unw(row2[pix],row2[pix-1])+unw(row2[pix],row3[0])-3*row2[0]);		
	rowf[pix]=abs(unw(row2[pix],row2[pix-1])+unw(row2[pix],row3[pix-1])+unw(row2[pix],row3[pix])-3*row2[pix]);
	for (i=in->stx+1;i<pix;i++)//Rajout +1
	{
		memo=row2[i];
		rowf[i]=abs(unw(memo,row2[i-1])+unw(memo,row2[i+1])-2*memo)+abs(unw(memo,row3[i-1])+unw(memo,row3[i])+unw(memo,row3[i+1])-3*memo);
	}
	err=WriteRow(out,in->stx,rowf);
	for (line=in->stx;line<in->endy;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=ptr;
		err=ReadRow(in,line+1,row3);
		rowf[0]=abs(unw(row2[0],row2[1])+unw(row2[0],row1[1])+unw(row2[0],row3[1])-3*row2[0])+abs(unw(row2[0],row1[0])+unw(row2[0],row3[0])-2*row2[0]);

		rowf[pix]=abs(unw(row2[pix],row1[pix])+unw(row2[pix],row3[pix])-2*row2[pix])+abs(unw(row2[pix],row1[pix-1])+unw(row2[pix],row2[pix-1])+unw(row2[pix],row3[pix-1])-3*row2[pix]);
		for(i=in->stx+1;i<pix;i++)//Rajout +1
		{
			memo=row2[i];
			rowf[i]=abs(unw(memo,row2[i-1])+unw(memo,row2[i+1])-2*memo)+abs(unw(memo,row3[i-1])+unw(memo,row1[i+1])-2*memo)+abs(unw(memo,row3[i+1])+unw(memo,row1[i-1])-2*memo)+abs(unw(memo,row1[i])+unw(memo,row3[i])-2*memo);

		}
		err=WriteRow(out,line,rowf);
	}

	rowf[0]=abs(unw(row3[0],row2[1])+unw(row3[0],row3[1])+unw(row3[0],row2[0])-3*row3[0]);
	rowf[pix]=abs(unw(row3[pix],row2[pix-1])+unw(row3[pix],row3[pix-1])+unw(row3[pix],row2[pix])-3*row3[pix]);
	for(i=in->stx+1;i<pix;i++)//Rajout +1
	{
		memo=row3[i];
		rowf[i]=abs(unw(memo,row3[i-1])+unw(memo,row3[i+1])-2*memo)+abs(unw(memo,row2[i-1])+unw(memo,row2[i])+unw(memo,row2[i+1])-3*memo);
	}
	err=WriteRow(out,line,rowf);
	delete row1;
	delete row2;
	delete row3;
	delete rowf;
	return err;
}
//5. Filtre maison
int CDemodul::sunwfilt(imgdes *in,imgdes *out)
{
	short 
		i,memo,line,
		*row1,*row2,*row3,*rowf,*ptr,
		pix,
		err=0;
	pix=in->endx;
	rowf=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];
	pix--;
	err=ReadRow(in,in->stx,row2);
	err=ReadRow(in,in->stx+1,row3);
	rowf[0]=((unw(row2[0],row2[1])+unw(row2[0],row3[1])+unw(row2[0],row3[0])+row2[0])/4+256)%256;
	rowf[pix]=((unw(row2[pix],row2[pix-1])+unw(row2[pix],row3[pix-1])+unw(row2[pix],row3[pix])+row2[pix])/4+256)%256;
	for (i=in->stx+1;i<pix;i++)//Rajout 1
	{
		memo=row2[i];
		rowf[i]=((unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row3[i])+unw(memo,row3[i+1])+memo)/6+256)%256;
	}
	err=WriteRow(out,in->stx,rowf);
	for (line=in->stx+1;line<in->endx;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=ptr;
		err=ReadRow(in,line+1,row3);
		rowf[0]=((unw(row2[0],row2[1])+unw(row2[0],row1[1])+unw(row2[0],row3[1])+unw(row2[0],row1[0])+unw(row2[0],row3[0])+row2[0])/6+256)%256;
		rowf[pix]=((unw(row2[pix],row1[pix])+unw(row2[pix],row2[pix-1])+unw(row2[pix],row1[pix-1])+unw(row2[pix],row3[pix])+unw(row2[pix],row3[pix-1])+row2[pix])/6+256)%256;
		for (i=in->stx+1;i<pix;i++)//Rajout 1
		{
			memo=row2[i];
			rowf[i]=((unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row3[i])+unw(memo,row3[i+1])+unw(memo,row1[i-1])+unw(memo,row1[i])+unw(memo,row1[i+1])+memo)/9+256)%256;
		}
		err=WriteRow(out,line,rowf);
	}
	rowf[0]=((unw(row3[0],row2[1])+unw(row3[0],row3[1])+unw(row3[0],row2[0])+row3[0])/4+256)%256;
	rowf[pix]=((unw(row3[pix],row2[pix-1])+unw(row3[pix],row3[pix-1])+unw(row3[pix],row2[pix])+row3[pix])/4+256)%256;
	for (i=in->stx+1;i<pix;i++)//Rajout 1
	{
		memo=row3[i];
		rowf[i]=((unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row2[i])+unw(memo,row3[i+1])+memo)/6+256)%256;

	}
	err=WriteRow(out,line,rowf);
	delete row1;
	delete row2;
	delete row3;
	delete rowf;
	return err;
}
//6. Moindres carrs 5x5
int CDemodul::s55mincarre(imgdes *in,imgdes *out)
{
	short
		i,line,memo, 
		err=0,
		pix,
		*row1,*row2,*row3,*row4,*row5,*rowf1,*rowf2,*rowf3,*ptr,
		a,b,b1,b2,b3,b4,b5;

	//Nb.de pixels horizontaux
	pix=in->endx;
	//Allocation dynamique colonnes
	rowf1=new short[pix];
	rowf2=new short[pix];
	rowf3=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];
	row4=new short[pix];
	row5=new short[pix];

	pix--;
	err=ReadRow(in,in->stx,row1);
	err=ReadRow(in,in->stx+1,row2);
	err=ReadRow(in,in->stx+2,row3);
	err=ReadRow(in,in->stx+3,row4);
	err=ReadRow(in,in->stx+4,row5);
	memo=row3[2];
	a=(unw(memo,row1[3])+unw(memo,row2[3])+unw(memo,row3[3])+unw(memo,row4[3])+unw(memo,row5[3])+unw(memo,row1[4])+unw(memo,row2[4])+unw(memo,row3[4])+unw(memo,row4[4])+unw(memo,row5[4])-unw(memo,row1[1])-unw(memo,row2[1])-unw(memo,row3[1])-unw(memo,row4[1])-unw(memo,row5[1])-unw(memo,row1[0])-unw(memo,row2[0])-unw(memo,row3[0])-unw(memo,row4[0])-unw(memo,row5[0]))/30;
	b=(unw(memo,row5[4])+unw(memo,row5[3])+unw(memo,row5[2])+unw(memo,row5[1])+unw(memo,row5[0])+unw(memo,row4[4])+unw(memo,row4[3])+unw(memo,row4[2])+unw(memo,row4[1])+unw(memo,row4[0])-unw(memo,row2[4])-unw(memo,row2[3])-unw(memo,row2[2])-unw(memo,row2[1])-unw(memo,row2[0])-unw(memo,row1[4])-unw(memo,row1[3])-unw(memo,row1[2])-unw(memo,row1[1])-unw(memo,row1[0]))/30;
	rowf1[0]=diff(row1[1],row1[0]+a)+diff(row2[1],row1[0]+a+b)+diff(row2[0],row1[0]+b);
	rowf2[0]=diff(row2[1],row2[0]+a)+diff(row3[1],row2[0]+a+b)+diff(row3[0],row2[0]+b)+diff(row1[0],row2[0]-b)+diff(row1[1],row2[0]+a-b);
	rowf1[1]=diff(row2[1],row1[1]+b)+diff(row1[2],row1[1]+a)+diff(row1[0],row1[1]-a)+diff(row2[0],row1[1]-a+b)+diff(row2[2],row1[1]+a+b);
	rowf2[1]=diff(row2[2],row2[1]+a)+diff(row3[2],row2[1]+a+b)+diff(row3[1],row2[1]+b)+diff(row1[1],row2[1]-b)+diff(row1[2],row2[1]+a-b)+diff(row2[0],row2[1]-a)+diff(row1[0],row2[1]-a-b)+diff(row3[0],row2[1]-a+b);
	rowf3[0]=diff(row3[1],row3[0]+a)+diff(row4[1],row3[0]+a+b)+diff(row4[0],row3[0]+b)+diff(row2[0],row3[0]-b)+diff(row2[1],row3[0]+a-b);
	rowf1[2]=diff(row2[2],row1[2]+b)+diff(row1[3],row1[2]+a)+diff(row1[1],row1[2]-a)+diff(row2[1],row1[2]-a+b)+diff(row2[3],row1[2]+a+b);
	rowf2[2]=diff(row2[3],row2[2]+a)+diff(row3[3],row2[2]+a+b)+diff(row3[2],row2[2]+b)+diff(row1[2],row2[2]-b)+diff(row1[3],row2[2]+a-b)+diff(row2[1],row2[2]-a)+diff(row1[1],row2[2]-a-b)+diff(row3[1],row2[2]-a+b);
	rowf3[1]=diff(row3[2],row3[1]+a)+diff(row4[2],row3[1]+a+b)+diff(row4[1],row3[1]+b)+diff(row2[1],row3[1]-b)+diff(row2[2],row3[1]+a-b)+diff(row3[0],row3[1]-a)+diff(row2[0],row3[1]-a-b)+diff(row4[0],row3[1]-a+b);
	rowf3[2]=diff(row3[3],row3[2]+a)+diff(row4[3],row3[2]+a+b)+diff(row4[2],row3[2]+b)+diff(row2[2],row3[2]-b)+diff(row2[3],row3[2]+a-b)+diff(row3[1],row3[2]-a)+diff(row2[1],row3[2]-a-b)+diff(row4[1],row3[2]-a+b);

	for (i=in->stx+2;i<pix-2;i++)
	{
		memo=row3[i];
		a=(unw(memo,row1[i+1])+unw(memo,row2[i+1])+unw(memo,row3[i+1])+unw(memo,row4[i+1])+unw(memo,row5[i+1])+unw(memo,row1[i+2])+unw(memo,row2[i+2])+unw(memo,row3[i+2])+unw(memo,row4[i+2])+unw(memo,row5[i+2])-unw(memo,row1[i-1])-unw(memo,row2[i-1])-unw(memo,row3[i-1])-unw(memo,row4[i-1])-unw(memo,row5[i-1])-unw(memo,row1[i-2])-unw(memo,row2[i-2])-unw(memo,row3[i-2])-unw(memo,row4[i-2])-unw(memo,row5[i-2]))/30;
		b=(unw(memo,row5[i+2])+unw(memo,row5[i+1])+unw(memo,row5[i])+unw(memo,row5[i-1])+unw(memo,row5[i-2])+unw(memo,row4[i+2])+unw(memo,row4[i+1])+unw(memo,row4[i])+unw(memo,row4[i-1])+unw(memo,row4[i-2])-unw(memo,row2[i+2])-unw(memo,row2[i+1])-unw(memo,row2[i])-unw(memo,row2[i-1])-unw(memo,row2[i-2])-unw(memo,row1[i+2])-unw(memo,row1[i+1])-unw(memo,row1[i])-unw(memo,row1[i-1])-unw(memo,row1[i-2]))/30;
		rowf3[i]=diff(row3[i+1],memo+a)+diff(row4[i+1],memo+a+b)+diff(row2[i+1],memo+a-b)+diff(row3[i-1],memo-a)+diff(row2[i-1],memo-a-b)+diff(row4[i-1],memo-a+b);
		rowf2[i]=diff(row2[i+1],row2[i]+a)+diff(row3[i+1],row2[i]+a+b)+diff(memo,row2[i]+b)+diff(row1[i],row2[i]-b)+diff(row1[i-1],row2[i]-a-b)+diff(row3[i-1],row2[i]-a+b);
		rowf1[i]=diff(row2[i],row1[i]+b)+diff(row1[i+1],row1[i]+a)+diff(row1[i-1],row1[i]-a)+diff(row2[i-1],row1[i]-a+b)+diff(row2[i+1],row1[i]+a+b);

	}
	rowf1[pix-1]=rowf2[pix-1]=rowf3[pix-1]=rowf1[pix]=rowf2[pix]=rowf3[pix]=741;
	err=WriteRow(out,in->stx,rowf1);
	err=WriteRow(out,in->stx+1,rowf2);
	err=WriteRow(out,in->stx+2,rowf3);
	for (line=in->sty+3;line<in->endy-1;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=row4;
		row4=row5;
		row5=ptr;
		err=ReadRow(in,line+2,row5);
		memo=row3[2];
		a=(unw(memo,row1[3])+unw(memo,row2[3])+unw(memo,row3[3])+unw(memo,row4[3])+unw(memo,row5[3])+unw(memo,row1[4])+unw(memo,row2[4])+unw(memo,row3[4])+unw(memo,row4[4])+unw(memo,row5[4])-unw(memo,row1[1])-unw(memo,row2[1])-unw(memo,row3[1])-unw(memo,row4[1])-unw(memo,row5[1])-unw(memo,row1[0])-unw(memo,row2[0])-unw(memo,row3[0])-unw(memo,row4[0])-unw(memo,row5[0]))/30;
		b5=unw(memo,row5[4])+unw(memo,row4[4])-unw(memo,row2[4])-unw(memo,row1[4]);	
		b4=unw(memo,row5[3])+unw(memo,row4[3])-unw(memo,row2[3])-unw(memo,row1[3]);	
		b3=unw(memo,row5[2])+unw(memo,row4[2])-unw(memo,row2[2])-unw(memo,row1[2]);	
		b2=unw(memo,row5[1])+unw(memo,row4[1])-unw(memo,row2[1])-unw(memo,row1[1]);	
		b1=unw(memo,row5[0])+unw(memo,row4[0])-unw(memo,row2[0])-unw(memo,row1[0]);
		b=(b5+b4+b3+b2+b1)/30;
		rowf3[0]=diff(row3[1],row3[0]+a)+diff(row4[1],row3[0]+a+b)+diff(row4[0],row3[0]+b)+diff(row2[0],row3[0]-b)+diff(row2[1],row3[0]+a-b);
		rowf3[1]=diff(memo,row3[1]+a)+diff(row4[2],row3[1]+a+b)+diff(row4[1],row3[1]+b)+diff(row2[1],row3[1]-b)+diff(row2[2],row3[1]+a-b)+diff(row3[0],row3[1]-a)+diff(row2[0],row3[1]-a-b)+diff(row4[0],row3[1]-a+b);
		rowf3[2]=diff(row3[3],memo+a)+diff(row4[3],memo+a+b)+diff(row4[2],memo+b)+diff(row2[2],memo-b)+diff(row2[3],memo+a-b)+diff(row3[1],memo-a)+diff(row2[1],memo-a-b)+diff(row4[1],memo-a+b);
		for (i=in->stx+2;i<pix-1;i++)
		{
			memo=row3[i];
			b1=b2;b2=b3;b3=b4;b4=b5;
			b5=unw(memo,row5[i+2])+unw(memo,row4[i+2])-unw(memo,row2[i+2])-unw(memo,row1[i+2]);	
			b=(b5+b4+b3+b2+b1)/30;
			a=(unw(memo,row1[i+1])+unw(memo,row2[i+1])+unw(memo,row3[i+1])+unw(memo,row4[i+1])+unw(memo,row5[i+1])+unw(memo,row1[i+2])+unw(memo,row2[i+2])+unw(memo,row3[i+2])+unw(memo,row4[i+2])+unw(memo,row5[i+2])-unw(memo,row1[i-1])-unw(memo,row2[i-1])-unw(memo,row3[i-1])-unw(memo,row4[i-1])-unw(memo,row5[i-1])-unw(memo,row1[i-2])-unw(memo,row2[i-2])-unw(memo,row3[i-2])-unw(memo,row4[i-2])-unw(memo,row5[i-2]))/30;
			rowf3[i]=diff(row3[i+1],memo+a)+diff(row4[i+1],memo+a+b)+diff(row4[i],memo+b)+diff(row2[i],memo-b)+diff(row2[i+1],memo+a-b)+diff(row3[i-1],memo-a)+diff(row2[i-1],memo-a-b)+diff(row4[i-1],memo-a+b);
		}
		rowf3[pix-1]=rowf3[pix]=822;
		err=WriteRow(out,line,rowf3);
	}
	err=WriteRow(out,line+1,rowf3);
	err=WriteRow(out,line,rowf3);
	delete row1;
	delete row2;
	delete row3;
	delete row4;
	delete row5;
	delete rowf1;
	delete rowf2;
	delete rowf3;
	return err;
}
//7. Laplacien
int CDemodul::sunwlapl(imgdes *in,imgdes *out)
{
	short
		i,line,memo, 
		err=0,
		pix,
		*row1,*row2,*row3,*rowf,*ptr;
	
	//Nb.de pixels horizontaux
	pix=in->endx;
	//Allocation dynamique colonnes
	rowf=new short[pix];
	row1=new short[pix];
	row2=new short[pix];
	row3=new short[pix];

	pix--;
	err=ReadRow(in,in->stx,row2);
	err=ReadRow(in,in->stx+1,row3);
	rowf[0]=abs(unw(row2[0],row2[1])+unw(row2[0],row3[1])+unw(row2[0],row3[0])-3*row2[0]);
	rowf[pix]=abs(unw(row2[pix],row2[pix-1])+unw(row2[pix],row3[pix-1])+unw(row2[pix],row3[pix])-3*row2[pix]);
	for (i=in->stx;i<pix;i++)
	{
		memo=row2[i];
		rowf[i]=abs(unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row3[i])+unw(memo,row3[i+1])-5*memo);
	}
	err=WriteRow(out,1,rowf);
	for (line=in->sty;line<in->endy;line++)
	{
		ptr=row1;
		row1=row2;
		row2=row3;
		row3=ptr;
		err=ReadRow(in,line+1,row3);
		rowf[0]=abs(unw(row2[0],row2[1])+unw(row2[0],row1[1])+unw(row2[0],row3[1])+unw(row2[0],row1[0])+unw(row2[0],row3[0])-5*row2[0]);
		rowf[pix]=abs(unw(row2[pix],row1[pix])+unw(row2[pix],row2[pix-1])+unw(row2[pix],row1[pix-1])+unw(row2[pix],row3[pix])+unw(row2[pix],row3[pix-1])-5*row2[pix]);

		for (i=in->stx;i<pix;i++)
		{
			memo=row2[i];
			rowf[i]=abs(unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row3[i])+unw(memo,row3[i+1])+unw(memo,row1[i-1])+unw(memo,row1[i])+unw(memo,row1[i+1])-8*memo);
		}
		err=WriteRow(out,line,rowf);
	}
	rowf[0]=abs(unw(row3[0],row2[1])+unw(row3[0],row3[1])+unw(row3[0],row2[0])-3*row3[0]);
	rowf[pix]=abs(unw(row3[pix],row2[pix-1])+unw(row3[pix],row3[pix-1])+unw(row3[pix],row2[pix])-3*row3[pix]);

	for (i=in->stx;i<pix;i++)
	{
		memo=row3[i];
		rowf[i]=abs(unw(memo,row2[i-1])+unw(memo,row2[i+1])+unw(memo,row3[i-1])+unw(memo,row2[i])+unw(memo,row3[i+1])-5*memo);
	}
	err=WriteRow(out,line,rowf);

	delete row1;
	delete row2;
	delete row3;
	delete rowf;
	return err;
}
//Dewrapping______________________________
short CDemodul::sdewrap(void)
{
	CString s;
	int 
		pix_per_row,
		rcode;
	long max,min,w,*trans,*histo,ival[2],Npix,*trans_zone;
	short 
		x,y,k,
		*buf,
		M=0,
		err,i,a,b;
	float 
		value[3],
		lev[2];
	
	pix_per_row=in->endx+1;

	//Mise  zro image out
	ZeroImage(0,out);
	Ajoute("Mise  zro image out");
	//Image normale ?
	if (mode&16)
	{
		Ajoute("Fonction de mrite variance");
		sunwvar(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}

	//Linarit ?
	if (mode&1024)
	{
		Ajoute("Fonction de mrite linarit");
		sunlin(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}
	//Laplacien ?
	if (mode&512)
	{
		Ajoute("Fonction de mrite laplacien");
		sunwlapl(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}
	//On dtecte les discontinuits ?
	if (mode&1)
	{
		Ajoute("Dtection discontinuits, appel smincarre 3x3");
		//Moindres carrs 3x3
		smincarre(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}

	//Fonction de mrite moindres carrs 5x5
	if (mode&2048)
	{
		Ajoute("Fonction de mrite smincarre 5x5");
		//Moindres carrs 5x5
		s55mincarre(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}
	//Franges serres, on dtecte les ples
	if (mode&4)
	{
		Ajoute("Dtection ples (appel sptsfoi)");
		//Points foireux
		sptsfoi(in,labl);
		//Addition
		IpAritimg(out,labl,out,V_ADD);
	}
	//Fin dtection ples___________________
	histo=new long[3561];
	if (histo==NULL) 
	{
		Ajoute("Erreur rservation mmoire histo");
		goto the_end;
	}
	
	//Elimine fond continu ?
	if (mode&8)
	{
		//Dtection bruit de type I, valeur nulle fonction de mrite
		Ajoute("Dtection bruit de type 1");
	}
	if (mode&64)
	{
		//Algorithme type 2, voir page 97
		zeroimage(0,labl);
		zeroimage(0,brouillon);
	
		lev[0]=lev[1]=0;
		//Met  255 tous les pixels d'intensit 0 et les autres  0
		IpThr(out,labl,lev,value,V_BIN);

		IpHisto(in,0,255,&ival[0],&ival[1],histo);
		a=0;Npix=0;
		for (i=0;i<256;i++)
		{
			if (histo[i]>Npix)
			{
				a=i;Npix=histo[i];
			}
			histo[i]=0;
		}
		s.Format("Elimination fond continu (wBruit: %d)",a);
		Ajoute(s);

		lev[0]=lev[1]=a;
		IpThr(in,brouillon,lev,value,V_BIN);
		IpRecon(brouillon,labl,labl);
		IpBoolVal(labl,0,brouillon,V_NOT); //Ngatif  priori...
		
		if (mode&32)
		{
			Ajoute("Erosion de l'image (bruit important)");
			//Dtection de bruit de fond type 3 (type 2 + rosion)
			IpErode(brouillon,brouillon,1);
		}
		else
			mode+=32;
		IpAritval(out,1,out,V_ADD);
		IpMask(out,brouillon,out);

		//zeroimage(0,labl);
		zeroimage(0,brouillon);
	}
	
	//Masquage, partie I
	if (mode&256)
	{
		Ajoute("Masquage");
		IpMask(out,mask,out);
		//Les points d'intensit nulle de la fonction de mrite sont mis en file 20, idem  dtection de bruit type 1
		if (!(mode&8)) mode+=8;
	}
	
	//Prtraitement des images
	//Histogramme de la fonction de mrite...
	IpHisto(out,0,3560,&ival[0],&ival[1],histo);
	if (ival[0]<0 || ival[1]>3560)
	{
		s.Format("Erreur de prtraitement image out, w [%d, %d]",ival[0],ival[1]);
		Ajoute(s);
		err=-1;
		delete histo;
		goto the_end;
	}
	else
	{
		s.Format("Prtraitement image out pour w [%d, %d]",ival[0],ival[1]);
		Ajoute(s);
	}
	//Tableau contenant autant d'entres qu'il y a de valeurs diffrentes de la fonction de mrite
	trans=new long[ival[1]-ival[0]+1];
	if (trans==NULL) 
	{
		Ajoute("Erreur rservation mmoire trans");
		delete histo;
		goto the_end;
	}
	Npix=0;a=0;
	for (i=0;i<50;i++) repartition[i]=0;
	if (mode&8)
	{
		//Bruit de fond type 1
		//Les points d'intensit nulle sont mis en file 20
		Ajoute("Points d'intensit nulle mis file 20");
		trans[0]=20;
		repartition[20]=histo[0];
		for (i=ival[0]+1;i<=ival[1];i++)
		{
			Npix+=histo[i];
			trans[i-ival[0]]=a;
			if (Npix>(pix_per_row*in->endy-histo[0])*(a+1)/20)
			{
				//repartition contient le nb. de pixels pour chacune des 20 valeurs de la fonction de mrite
				repartition[a]=Npix-repartition[a];
				a++;
				repartition[a]=Npix;
			}
		}
	}
	else
	{
		//Pas de dtection de bruit type 1 et pas de masque
		//Points d'intensit nulle dans file 0, etc...
		for (i=ival[0];i<=ival[1];i++)
		{
			Npix=Npix+histo[i];
			trans[i-ival[0]]=a;
			if (Npix>pix_per_row*in->endy*(a+1)/20)
			{
				repartition[a]=Npix-repartition[a];
				a++;
				repartition[a]=Npix;
			}
		}
	}
	if (a>25)
	{
		Ajoute("Erreur 2 dtecte (a>25)");
		delete histo;
		delete trans;
		err=-2;
		goto the_end;
	}

	Ajoute("Appel anamorphoseur");
	//Transformation de l'image de la fonction de mrite en une image
	//de la fonction de mrite dans l'intervalle [0,20]
	//Remplacer tous les pixels au niveau n par la nime valeur du tableau trans
	IpAnam(out,labl,ival,trans,0,50);

	//Comptage du nombre de pixel pour chaque file
	for (i=0;i<50;i++) repartition[i]=0;
	for (x=labl->stx;x<=labl->endx;x++)
	{
		for (y=labl->sty;y<=labl->endy;y++)
		{
			Npix=getpixelcolor(labl,x,y);
			if (Npix<0 || Npix>50)
			{
				AfxMessageBox("Erreur");
			}
			else
			{
				repartition[Npix]++;
			}
		}
	}
	delete histo;delete trans;
	
	//Mettre un point de qualit 3 dans la file n3, et ainsi de suite...
	i=0;
	do
	{
		f[i]=new file_node[repartition[i]];
		if (f[i]==NULL)
		{ 
			s.Format("Erreur cration file n%d de taille %d octet(s)",i,repartition[i]);
			Ajoute(s);
		}
		else
		{
			//s.Format("File %d de taille %d octet(s) cre",i,repartition[i]);
			//Ajoute(s);
		}
		i++;
	}
	while (i<50 && f[i-1]!=NULL);

	file=new long[55];if (file==NULL) Ajoute("Erreur cration index file");
	file_fin=new long[55];if (file_fin==NULL) Ajoute("Erreur cration index file_fin");
	
	if (i<50) 
	{
		goto the_end;
	}
	
	//Affectation de file et file_fin
	for (i=0;i<50;i++)
	{
		file[i]=0;
		file_fin[i]=0;
	}

	if (mode&128)
		//Image label
		n_zone=-51;
	else
		//Pas d'image label		
		n_zone=-1;

	//Inhibation cadre de l'image de la fonction de mrite
	for (x=labl->stx;x<=labl->endx;x++)
	{
		setpixelcolor(labl,x,labl->sty,255+n_zone);
		setpixelcolor(labl,x,labl->endy,255+n_zone);
	}
	for (y=labl->sty;y<=labl->endy;y++)
	{
		setpixelcolor(labl,labl->stx,y,255+n_zone);
		setpixelcolor(labl,labl->endx,y,255+n_zone);
	}

	//Initialisation: tous les pixels de l'image ordre des franges mis  255
	ZeroImage(255,correction);
	s.Format("Initialisation image ordre des franges (w=255)");
	Ajoute(s);

	//Ici on modifie les pointeurs, filtrage, ... en fonction du mode
	//Masque deux le retour?
	if (mode&256)
	{
		Ajoute("On ignore les points noirs du masque");
		//Tous les points noirs du masque sont  ignorer
		for (x=mask->stx;x<=mask->endx;x++)
		{
			for (y=mask->sty;y<=mask->endy;y++)
			{
				w=getpixelcolor(mask,x,y);
				if (w==0)
				{
					//On les ignore dans l'image de la fonction de mrite
					setpixelcolor(labl,x,y,254);
				}
			}
		}
	}
	if (mode&128)
	{
		//Image label
		trans_zone=new long[2048];
		if (trans_zone==NULL) 
			Ajoute("Erreur rservation mmoire trans_zone");
		else
			Ajoute("Mmoire trans_zone rserve");
	}

	//Ici commence le travail proprement dit...
	if (mode&128)
	{
		//Image label
		//x=(int)in->endx/10;
		//y=(int)in->endy/10;
		x=(int)in->endx/3;
		y=(int)in->endy/3;
	}
	else
	{
		x=(int)in->endx/3;
		y=(int)in->endy/3;
	}

	recherche(labl,&x,&y);
	s.Format("Point %d,%d  laplacien nul trouv dans l'image",x,y);
	Ajoute(s);

	debut://________________________________
	//Voir pages 43 et 64
	//Le point au centre de l'image de coordonnes x,y est mis dans la file
	setpixelcolor(labl,x,y,255+n_zone);
	//Ordre des franges arbitrairement  100 pour ce point
	setpixelcolor(correction,x,y,100);
	//On regarde les 8 voisins et on les met dans la bonne file
	for (i=-1;i<=1;i++)
	{
		for (a=-1;a<=1;a++)
		{
			b=getpixelcolor(labl,x+i,y+a);
			if (b>=0 && b<50)
			{
				k=file_fin[b];
				//s.Format("Point %d,%d mis dans file %d en n%d",x+i,y+a,b,k);Ajoute(s);
				f[b][k].x=x+i;
				f[b][k].y=y+a;
				file_fin[b]++;
				//Le point x+i,y+a est mis dans la file
				setpixelcolor(labl,x+i,y+a,255+n_zone);
			}
		}
	}
	//On passe en revue toutes les 21 files jusqu'a ce qu'elles soient vides
	//On commence toujours par les pts de bonne qualit en file 0	
	i=0;
	while (i<21)
	{
		if (file[i]==file_fin[i]) 
		{
			i++;
		}
		else
		{
			ajoute(i);
			i=0;
		}
	}
	
	y=(int)in->endy/10;
	x=(int)in->endx/10;

	//if (recherche(labl,&x,&y)) goto debut;

	//Bilan
	/*
	for (x=0;x<=20;x++)
	{
		s.Format("Taille file %d utilise: %d octet(s)",x,file_fin[x]);
		Ajoute(s);
	}
	*/
	Ajoute("Cration des images dfinitives");
	//Recherche des valeurs mini/maxi de l'image ordre des franges
	min=2048;
	max=-2048;
	for (x=correction->stx+2;x<=correction->endx-2;x++)
	{
		for (y=correction->sty+2;y<=correction->endy-2;y++)
		{
			w=getpixelcolor(correction,x,y);
			if (mode&256)
			{
				//Masque dfini
				if(getpixelcolor(mask,x,y)!=0)
				{
					if (w<min) min=w;
					if (w>max) max=w;
				}
			}
			else
			{
				//Valeur mini/maxi
				if (w<min) min=w;
				if (w>max) max=w;
			}
		}
	}

	//Calcul du nb. M des ordres de frange
	M=max-min;	
	//Soustraction de 1  M
	//Invalid le 23/06/03
	//M--;if (M<0) M=0;
	s.Format("Nb. de sauts M = %d",M);
	Ajoute(s);

	//Ramener l'image ordre des franges dans [0, max-min]
	for (x=correction->stx;x<=correction->endx;x++)
	{
		for (y=correction->sty;y<=correction->endy;y++)
		{
			w=getpixelcolor(correction,x,y);
			if (mode&256)
			{
				//Masque dfini
				if(getpixelcolor(mask,x,y)==0)
					w=0;
				else
					w=w-min;
			}
			else
				w=w-min;
			setpixelcolor(correction,x,y,w);
		}
	}

	//Multiplication de l'image ordre des franges par 256 --> brouillon
	IpAritval(correction,256,brouillon,V_MUL);

	//IpAritimg(brouillon,in,out,V_ADD);
	for (x=in->stx;x<=in->endx;x++)
	{
		for (y=in->sty;y<=in->endy;y++)
		{
			if (mode&256)
			{
				//Masque dfini
				if(getpixelcolor(mask,x,y)==0)
					w=0;
				else
					w=getpixelcolor(brouillon,x,y)+getpixelcolor(in,x,y);
			}
			else
			{
				w=getpixelcolor(brouillon,x,y)+getpixelcolor(in,x,y);
			}
			setpixelcolor(out,x,y,w);
		}
	}

	//Ramener l'image ordre des franges entre [0 et 250]
	for (x=correction->stx;x<=correction->endx;x++)
	{
		for (y=correction->sty;y<=correction->endy;y++)
		{
			w=getpixelcolor(correction,x,y);
			w=(long)(250.0*w/(max-min));
			//w=w*100;
			setpixelcolor(correction,x,y,w+256*w+256*256*w);
		}
	}
	//Ramener l'image out entre [0 et 255]
	min=10000;
	max=-10000;
	for (x=out->stx+2;x<=out->endx-2;x++)
	{
		for (y=out->sty+2;y<=out->endy-2;y++)
		{
			w=getpixelcolor(out,x,y);
			if (w<min) min=w;
			if (w>max) max=w;
		}
	}
	Ajoute("Image dmodule ramene dans l'intervalle [0,255]");
	for (x=out->stx+2;x<=out->endx-2;x++)
	{
		for (y=out->sty+2;y<=out->endy-2;y++)
		{
			w=getpixelcolor(out,x,y);
			w=w-min;
			w=(long)(255.0*w/(max-min));
			setpixelcolor(out,x,y,w+256*w+256*256*w);
		}
	}
	//Image out convertie en 8 bits
	colortogray(out,imt);
	freeimage(out);
	allocimage(out,m_pOut->m_iL,m_pOut->m_iH,8);
	copyimage(imt,out);
	m_pOut->m_iNbB=8;
	Ajoute("Conversion image dmodule en 8 bits");
	//Inversion sens de la dmodulation
	if (mode&4096)
	{
		Ajoute("Inversion sens de la dmodulation");
		for (x=out->stx+2;x<=out->endx-2;x++)
		{
			for (y=out->sty+2;y<=out->endy-2;y++)
			{
				//Inversion dmodulation, en tenant compte du masque
				if (mode&256)
				{
					//Tous les points noirs du masque sont  ignorer...
					w=getpixelcolor(mask,x,y);
				}
				else
				{
					w=1;
				}
				if (w>=1)
				{
					w=getpixelcolor(out,x,y);
					setpixelcolor(out,x,y,255-w);
				}
			}
		}
			//Inversion dmodulation, en tenant compte du masque
			if (mode&256)
			{
				//Tous les points noirs du masque sont  ignorer...
			}
			else
			{
			}
	
	}
	/*
	if (mode&128)
	{
		//Image label
		Ajoute("Elimination des trop petites zones -> A FAIRE !");
		if (trans_zone!=NULL) delete trans_zone;
	}
	*/

	the_end://______________________________
	for (i=0;i<50;i++) 
	{
		if (f[i]!=NULL) delete f[i];
	}
	if (file!=NULL) delete[] file;
	if (file_fin!=NULL) delete[] file_fin;
	
	if (err<0)	
		return err;
	else
		return M;
}
