// LogDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "LogDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CLogDlg dialog
CLogDlg::CLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLogDlg)
	m_radioType = -1;
	//}}AFX_DATA_INIT
}
void CLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogDlg)
	DDX_Control(pDX, IDC_SOURCE2, m_comboSource2);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_SOURCE, m_comboSource);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Radio(pDX, IDC_OP1, m_radioType);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CLogDlg, CDialog)
	//{{AFX_MSG_MAP(CLogDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CLogDlg message handlers
BOOL CLogDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short n,i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	m_radioType=3;//Soustraction M256 par dfaut
	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_comboSource.AddString(s);
			m_comboSource2.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	//Recherche N nouvelle image destination
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			//Image destination
			m_iI[j]=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	m_comboSource.GetLBText(0,s);
	m_comboSource.SetWindowText(s);	
	m_comboSource2.GetLBText(0,s);
	m_comboSource2.SetWindowText(s);	
	m_comboDest.GetLBText(0,s);
	m_comboDest.SetWindowText(s);	
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CLogDlg::OnOK() 
{
	short i,j,is,is2,id;
	long w,w1,w2;
	CBkDoc *ps,*ps2,*pd;
	UpdateData(TRUE);
	//Image source 1
	is=m_iI[m_comboSource.GetCurSel()];
	//Image source 2
	is2=m_iI[m_comboSource2.GetCurSel()];
	//Image destination
	id=m_iI[m_comboDest.GetCurSel()];

	//Si l'utilisateur n'a pas touch aux combos...
	//Premiers de la liste
	if (m_comboSource.GetCurSel()<0)
		is=m_iI[0];
	else
		is=m_iI[m_comboSource.GetCurSel()];
	
	if (m_comboSource2.GetCurSel()<0)
		is2=m_iI[0];
	else
		is2=m_iI[m_comboSource2.GetCurSel()];
	
	if (m_comboDest.GetCurSel()<0)
		id=m_iI[0];
	else
		id=m_iI[m_comboDest.GetCurSel()];

	ps=m_pApp->m_pDocument[is];
	ps2=m_pApp->m_pDocument[is2];
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pApp->GetDocument(id)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		pd=m_pApp->GetDocument(id);
	}
	else
	{
		//Pointeur sur destination
		pd=m_pApp->GetDocument(id);
	}
	//Dimensionner la fentre destination  la taille de l'image source 1
	short l,h,nbB;
	l=ps->image->endx-ps->image->stx+1;
	h=ps->image->endy-ps->image->sty+1;
	nbB=ps->image->bmh->biBitCount;
	pd->InitialiserImage(l,h,nbB);
	pd->DimensionnerFenetre(l,h);
	pd->DefinirCurseurs(l,h);
	pd->PositionnerFenetre(0,0);
	pd->m_iType=0;
	pd->m_sNomFic.Format("OpMathLog");
	pd->EcritTitre();
	switch (m_radioType)
	{
		case 0://Addition
			addimage(ps->image,ps2->image,pd->image);
		break;	
		case 1://Addition modulo 256
			for (i=0;i<ps->m_iL;i++)
			{
				for (j=0;j<ps->m_iH;j++)
				{
					w1=getpixelcolor(ps->image,i,j);
					w2=getpixelcolor(ps2->image,i,j);
					if (w1+w2>=256)
					{
						w=w1+w2-256;
					}
					else
					{
						w=w1+w2;
					}
					setpixelcolor(pd->image,i,j,w);
				}
			}
		break;	
		case 2://Soustraction
			subimage(ps->image,ps2->image,pd->image);
		break;
		case 3://Soustraction modulo 256
			for (i=0;i<ps->m_iL;i++)
			{
				for (j=0;j<ps->m_iH;j++)
				{
					w1=getpixelcolor(ps->image,i,j);
					w2=getpixelcolor(ps2->image,i,j);
					w=w1-w2;
					if (w<0)
					{
						w=256+w;
					}
					setpixelcolor(pd->image,i,j,w);
				}
			}
		break;	
		case 4://ET
			andimage(ps->image,ps2->image,pd->image);
		break;	
		case 5://OU
			orimage(ps->image,ps2->image,pd->image);
		break;	
		case 6://XOR
			xorimage(ps->image,ps2->image,pd->image);
		break;	
		case 7://Multiplication
			for (i=0;i<ps->m_iL;i++)
			{
				for (j=0;j<ps->m_iH;j++)
				{
					w1=getpixelcolor(ps->image,i,j);
					w2=getpixelcolor(ps2->image,i,j);
					if (w1*w2>255)
					{
						w=255;
					}
					else
					{
						w=w1*w2;
					}
					setpixelcolor(pd->image,i,j,w);
				}
			}
		break;	
		case 8://Division
			for (i=0;i<ps->m_iL;i++)
			{
				for (j=0;j<ps->m_iH;j++)
				{
					w1=getpixelcolor(ps->image,i,j);
					w2=getpixelcolor(ps2->image,i,j);
					if (w1==0)
					{
						w=0;
					}
					else
					if (w2==0)
					{
						w=255;
					}
					else
					if(1.0*(w1/w2)>255)
					{
						w=255;
					}
					else
					{
						w=(long)(1.0*(w1/w2));
					}
					setpixelcolor(pd->image,i,j,w);
				}
			}
		break;	
	}
	delete m_iI;
	//Image dans fentre
	pd->m_iType=0;
	pd->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CLogDlg::OnCancel() 
{
	delete m_iI;
	CDialog::OnCancel();
}
