// Piezo.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "piezo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
CPiezo::CPiezo(int iNoCom)
{
	//Port srie
	m_radioCom=iNoCom;
	switch (m_radioCom)
	{
		case 0://COM1
			hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (hCom==INVALID_HANDLE_VALUE)
			{
				DWORD dwErreur=GetLastError();
			}
			else
				InitRs232(hCom);
		break;
		case 1://COM2
			hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (hCom==INVALID_HANDLE_VALUE)
				DWORD dwErreur=GetLastError();
			else
				InitRs232(hCom);
		break;
	}
}
//________________________________________
CPiezo::~CPiezo()
{
	if (hCom) CloseHandle(hCom);
}
//________________________________________
BOOL CPiezo::InitRs232(HANDLE hCom)
{
	DWORD taille;
	BOOL ok=TRUE;
	DCB dcb;
	COMMTIMEOUTS ctmo;
	//Paramtres du port srie
	ok=GetCommTimeouts(hCom,&ctmo);
	if (ok)
	{
		ctmo.ReadIntervalTimeout=MAXDWORD;
		ctmo.ReadTotalTimeoutMultiplier=0;
		ctmo.ReadTotalTimeoutConstant=0;
		ctmo.WriteTotalTimeoutConstant=0;
		ctmo.WriteTotalTimeoutMultiplier=0;
		SetCommTimeouts(hCom,&ctmo);
	}
	//9600,8,'O',2,RTS/CTS,CR
	//Voir stdafx.h
	GetCommState(hCom,&dcb);
	//Remplac le 23/10/03 par une fonction BuildCommDCB ...
	CString s="96,o,8,2,x";
	ok=BuildCommDCB(s,&dcb);
	if (!ok) AfxMessageBox("Erreur fonction BuildCommDCB");
	/*
	dcb.fOutxCtsFlow=1;			//CTS
	dcb.fOutxDsrFlow=0;
	dcb.fDtrControl=1;
	dcb.fDsrSensitivity=0;
	dcb.BaudRate=CBR_9600;	//9600 bauds
	dcb.fParity=1;					//Enable parity checking
	dcb.fTXContinueOnXoff=1;
	dcb.fOutX=0;
	dcb.fInX=0;
	dcb.fErrorChar=0;
	dcb.fNull=0;
	dcb.fRtsControl=2;			//RTS_CONTROL_HANDSHAKE
	dcb.fAbortOnError=1;
	//dcb.fDummy2=0;
	//dcb.XonLim=2048;
	//dcb.XoffLim=512;
	dcb.ByteSize=8;					//8 bits
	dcb.Parity=1;						//0:no, 1:odd, 2:even, 3:mark, 4:space
	dcb.StopBits=2;					//2 bits stop
	dcb.XonChar=17;
	dcb.XoffChar=19;
	dcb.ErrorChar=0;
	dcb.EofChar='\r';				//CR
	dcb.EvtChar=0;
	*/
	//Voir stdafx.h
	SetCommState(hCom,&dcb);
	return ok;
}
//__________________________________________________
BOOL CPiezo::WriteCom(char *s)
{
	BOOL ok;
	DWORD i;
	ok=WriteFile(hCom,s,strlen(s),&i,NULL);
	if (!ok || i!=strlen(s))
	{
		ok=FALSE;
	}
	return ok;
}
//__________________________________________________
void CPiezo::Tension(int u)
{
  char s[15],s2[2];
  unsigned int i;
	BOOL ok;

  i=(int)(1023.0*u/500.0); 
  if (i>1023) i=1023;
  sprintf(s,"%d\r",i);
	//ok=WriteCom(s);
	//On envoie caractre par caractre
	for (i=0;i<strlen(s);i++)
	{
 		sprintf(s2,"%c",s[i]);
 		ok==WriteCom(s2);
 		Sleep(20);
	}
}
