// bkview.h : interface of the CBkView class
//
//////////////////////////////////////////
class CBkView : public CView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
public:
	CBkDoc* GetDocument();

// Operations
public:
	class CBkApp *m_pApp;
	BOOL m_bBusy,m_OKCarte;
	short m_iCarte,m_ider,m_iNb;
	struct enreg
	{
		short i;
	};
	void l_enreg(FILE *f_dir,unsigned short i,struct enreg *e);
	void e_enreg(FILE *f_dir,unsigned short i,struct enreg *e);
	void MAJ_Fen();
	void FigerAcq();
	void AcqPerm();
	void InitCarte();


// Implementation
public:
	virtual ~CBkView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Printing support
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Generated message map functions
	virtual void OnInitialUpdate(); // called first time after construct


protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnUpdateAcqFig(CCmdUI* pCmdUI);
	afx_msg void OnAcqFig();
	afx_msg void OnUpdateAcqPerm(CCmdUI* pCmdUI);
	afx_msg void OnAcqPerm();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// debug version in bkview.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*) m_pDocument; }
#endif
//////////////////////////////////////////
