// AcqPhDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CAcqPhDlg dialog
class CAcqPhDlg : public CDialog
{
// Construction
public:
	CAcqPhDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAcqPhDlg)
	enum { IDD = IDD_ACQ_PHAS };
	CComboBox	m_comboDest;
	CComboBox	m_comboSource4;
	CComboBox	m_comboSource3;
	CComboBox	m_comboSource2;
	CComboBox	m_comboSource1;
	CButton	m_btnOK;
	int		m_radioTypDeph;
	CString	m_sTexte;
	BOOL	m_OKFiltre;
	CString	m_sU0;
	CString	m_sU1;
	CString	m_sU2;
	CString	m_sU3;
	CString	m_sU4;
	CString	m_sX1;
	CString	m_sX2;
	CString	m_sX3;
	CString	m_sX4;
	int		m_iTempo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcqPhDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkApp* m_pApp;
	class CPiezo *m_pPiezo;
	class CC832 *m_pC832;
	short 
		m_iU0,m_iU1,m_iU2,m_iU3,m_iU4,
		*m_iI;	//Affectation des N d'images dans la liste
	float m_fX1,m_fX2,m_fX3,m_fX4;
	BOOL 
		m_OK_NT,
		m_OK;

	float atan_bk_f(float n,float d);

	// Generated message map functions
	//{{AFX_MSG(CAcqPhDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
