// ExtractDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ExtractDlg.h"
#include "Bkdoc.h"
#include "Vicdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CExtractDlg dialog
CExtractDlg::CExtractDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExtractDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExtractDlg)
	m_sSource = _T("");
	m_s = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_EXTRACT,pParent);
}
//________________________________________
void CExtractDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExtractDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_SOURCE, m_sSource);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExtractDlg, CDialog)
	//{{AFX_MSG_MAP(CExtractDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CExtractDlg message handlers
void CExtractDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
void CExtractDlg::OnCancel() 
{
	m_pApp->m_pExtractDlg=NULL;	
	delete m_iI;
	//Pointeur sur le document courant
	class CBkDoc *pDoc;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()-> m_pMainWnd))-> MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL)
	{
		pDoc->InitTracker();
	}
	CDialog::OnCancel();
}
//__________________________________________________
void CExtractDlg::OnOK() 
{
	short 
		x,y,
		l,h,nbB,
		ls,hs,nbBs,ld,hd,nbBd,
		xd,yd,xa,ya;
	long w;
	if (m_ps!=NULL)
	{
		xd=m_ps->m_tracker.m_rect.left+m_ps->m_iXpos;	
		xa=m_ps->m_tracker.m_rect.right+m_ps->m_iXpos;
		yd=m_ps->m_tracker.m_rect.top+m_ps->m_iYpos;
		ya=m_ps->m_tracker.m_rect.bottom+m_ps->m_iYpos;
		//m_s.Format("(%d,%d), (%d,%d)",xd,yd,xa,ya);
		//UpdateData(FALSE);
		//Sleep(500);

		if (xd==0 && yd==0 && xa==0 && ya==0)
		{
			//Pas de tracker, on prend tout...
			xa=m_ps->m_iL;
			ya=m_ps->m_iH;
		}
		
		if (xd<0) xd=0;
		if (yd<0) yd=0;
		if (xa>m_ps->m_iL) xa=m_ps->m_iL;
		if (ya>m_ps->m_iH) ya=m_ps->m_iH;
		//La largeur de la bande extraite ne peut pas tre infrieure  140 pixels,
		//Pour cause de titre de fentre...
		//Taille destination demande
		ld=xa-xd+1;
		if (ld<140)
		{
			AfxMessageBox("Largeur fentre rajuste...");
			if (xd+140<m_ps->m_iL)
				xa=xd+140;
			else
				xd=xa-140;
			if (xd<0) xd=0;
		}

		//Dupliquer l'image source vers l'image temporaire n0
		//Si jamais source et destination sont identiques
		ls=m_ps->image->endx-m_ps->image->stx+1;
		hs=m_ps->image->endy-m_ps->image->sty+1;
		nbBs=m_ps->image->bmh->biBitCount;
		m_pApp->DupliquerImageDestTempo(m_iNoS,0);

		//Si l'utilisateur n'a pas touch au combo...
		if (m_comboDest.GetCurSel()<0) 
			m_iNoD=m_iI[m_comboDest.GetCount()-1];
		else
			m_iNoD=m_iI[m_comboDest.GetCurSel()];

		//Si la fentre destination n'existe pas, il faut la crer...
		if (m_pApp->GetDocument(m_iNoD)==NULL)
		{
			//L'image destination existe maintenant
			SendMessage(WM_COMMAND,ID_FILE_NEW,0);
			//Pointeur sur destination
			m_pd=m_pApp->m_pDocument[m_iNoD];
		}
		else
		{
			//Pointeur sur destination
			m_pd=m_pApp->m_pDocument[m_iNoD];
		}
		//Taille destination actuelle
		l=m_pd->image->endx-m_pd->image->stx+1;
		h=m_pd->image->endy-m_pd->image->sty+1;
		nbB=m_pd->image->bmh->biBitCount;
		//Taille destination demande
		ld=xa-xd+1;
		hd=ya-yd+1;
		nbBd=nbBs;
		if (l!=ld || h!=hd || nbB!=nbBd)
		{
			freeimage(m_pd->image);
			allocimage(m_pd->image,ld,hd,nbBd);
		}
		m_pd->m_iL=ld;
		m_pd->m_iH=hd;
		m_pd->DimensionnerFenetre(ld,hd);
		m_pd->DefinirCurseurs(ld,hd);
		m_pd->m_iType=0;
		m_pd->InitTracker();
		m_ps->InitTracker();
		m_pd->PositionnerFenetre(20,20);
		m_pd->m_sNomFic="Extract";
	
		//Copie de l'image
		for (x=xd;x<=xa;x++)
		{
			for (y=yd;y<=ya;y++)
			{
				w=getpixelcolor(m_pApp->imt[0],x,y);
				setpixelcolor(m_pd->image,x-xd,y-yd,w);
			}
		}
	}
	m_pApp->m_pExtractDlg=NULL;	
	delete m_iI;
	CDialog::OnOK();
}
//__________________________________________________
BOOL CExtractDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	m_iI=new short[m_pApp->m_iNbMax];
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()-> m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)
	{
		m_iNoS=m_ps->m_iNo;
		m_sSource.Format("%d",m_iNoS);
		//Initialisation tableau N images
		for (i=0;i<m_pApp->m_iNbMax;i++) m_iI[i]=-1;
		j=0;
		for (i=0;i<m_pApp->m_iNbMax;i++)
		{
			if (m_pApp->GetDocument(i)!=NULL /*&& i!=m_iNoS*/)
			{
				s.Format("Image %d",i);	
				m_comboDest.AddString(s);
				m_iI[j]=i;
				j++;
			}         
		}
		//Recherche N nouvelle image destination
		for (i=0;i<m_pApp->m_iNbMax;i++)
		{
			if (m_pApp->GetDocument(i)==NULL)
			{
				s.Format("IMAGE %d",i);	
				m_comboDest.AddString(s);
				//Image destination
				m_iI[j]=i;
				//On sort
				i=m_pApp->m_iNbMax;    
			}
		}
		//Par dfaut sur nouvelle image
		m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
		m_comboDest.SetWindowText(s);	
	}
	SetTimer(1,50,NULL);
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CExtractDlg::OnTimer(UINT nIDEvent) 
{
	//Vrification de l'image source
	//Pointeur sur le document courant
	CBkDoc *pDoc;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()-> m_pMainWnd))-> MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild-> GetActiveDocument(); else pDoc=NULL;
	if (pDoc==NULL)
	{
		m_btnOK.EnableWindow(FALSE);
		m_s.Format("L'image source n%d a t ferme...",m_iNoS);	
	}
	else
	if (pDoc!=m_ps)
	{
		m_btnOK.EnableWindow(FALSE);
		m_s.Format("Revenir  l'image source n%d...",m_iNoS);	
	}
	else
	{
		m_btnOK.EnableWindow(TRUE);
		m_s.Format("Slectionner une zone  la souris...");	
	}
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
