// MainFrm.cpp : implementation of the CMainFrame class
//
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "ProfilDlg.h"
#include "CalbDlg.h"
#include "CoteDlg.h"
#include "CoulDlg.h"
#include "ZoomDlg.h"
#include "FftDlg.h"
#include "AjustDlg.h"
#include "MathDlg.h"
#include "DemodDlg.h"
#include "MasqueDlg.h"
#include "LogDlg.h"
#include "PseuDlg.h"
#include "TemReDlg.h"
#include "Phas4Dlg.h"
#include "PiezoDlg.h"
#include "DepMaDlg.h"
#include "SurCoDlg.h"
#include "AcqPhDlg.h"
#include "FiltreDlg.h"
#include "MorphoDlg.h"
#include "ExtractDlg.h"
#include "MireDlg.h"
#include "SeuilDlg.h"
#include "Vicdefs.h"
//Pour Schwartz Yann______________________
#include "DepRoDlg.h"
#include "ParaMoDlg.h"
#include "DigiDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
///////////////////////////////////////////////////
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_PROFILS, OnProfils)
	ON_UPDATE_COMMAND_UI(ID_PROFILS, OnUpdateProfils)
	ON_COMMAND(ID_CALIBRER, OnCalibrer)
	ON_COMMAND(ID_COTER, OnCoter)
	ON_UPDATE_COMMAND_UI(ID_COTER, OnUpdateCoter)
	ON_COMMAND(ID_COULEURS, OnCouleurs)
	ON_COMMAND(ID_ZOOM_IMAGE, OnZoomImage)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_IMAGE, OnUpdateZoomImage)
	ON_COMMAND(ID_FFT2D, OnFft2d)
	ON_COMMAND(ID_AJUSTER_PARAMETRES, OnAjusterParametres)
	ON_COMMAND(ID_MUL_CTE, OnMulCte)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_COLLERLEPRESSEPAPIER, OnCollerlepressepapier)
	ON_COMMAND(ID_DEMODUL_IM_PHAS, OnDemodulImPhas)
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_UPDATE_COMMAND_UI(ID_MASQUE, OnUpdateMasque)
	ON_COMMAND(ID_MASQUE, OnMasque)
	ON_COMMAND(ID_OP_MATH_LOG, OnOpMathLog)
	ON_UPDATE_COMMAND_UI(ID_ACQ_FIG, OnUpdateAcqFig)
	ON_COMMAND(ID_ACQ_FIG, OnAcqFig)
	ON_UPDATE_COMMAND_UI(ID_ACQ_PERM, OnUpdateAcqPerm)
	ON_COMMAND(ID_ACQ_PERM, OnAcqPerm)
	ON_COMMAND(ID_VIISU_PSEUDO, OnViisuPseudo)
	ON_UPDATE_COMMAND_UI(ID_VIISU_PSEUDO, OnUpdateViisuPseudo)
	ON_UPDATE_COMMAND_UI(ID_TEMPS_REEL, OnUpdateTempsReel)
	ON_COMMAND(ID_TEMPS_REEL, OnTempsReel)
	ON_COMMAND(ID_CALCUL_IM_PHASE4, OnCalculImPhase4)
	ON_COMMAND(ID_DEP_MANU_MOT, OnDepManuMot)
	ON_COMMAND(ID_PILOTAGE_DEPH_STEIN, OnPilotageDephStein)
	ON_COMMAND(ID_AXE_SORTIE_SURCOURSE, OnAxeSortieSurcourse)
	ON_UPDATE_COMMAND_UI(ID_CALCUL_IM_PHASE4, OnUpdateCalculImPhase4)
	ON_COMMAND(ID_ACQ_IM_PHAS4, OnAcqImPhas4)
	ON_COMMAND(ID_FILTRES, OnFiltres)
	ON_UPDATE_COMMAND_UI(ID_AXE_SORTIE_SURCOURSE, OnUpdateAxeSortieSurcourse)
	ON_UPDATE_COMMAND_UI(ID_DEP_MANU_MOT, OnUpdateDepManuMot)
	ON_COMMAND(ID_EXTRACTION, OnExtraction)
	ON_UPDATE_COMMAND_UI(ID_EXTRACTION, OnUpdateExtraction)
	ON_UPDATE_COMMAND_UI(ID_CONVERSION_PSEUDO, OnUpdateConversionPseudo)
	ON_COMMAND(ID_CONVERSION_PSEUDO, OnConversionPseudo)
	ON_UPDATE_COMMAND_UI(ID_CONVERSION_NG, OnUpdateConversionNg)
	ON_COMMAND(ID_CONVERSION_NG, OnConversionNg)
	ON_UPDATE_COMMAND_UI(ID_FILE_NOUVEAU, OnUpdateFileNouveau)
	ON_COMMAND(ID_FILE_NOUVEAU, OnFileNouveau)
	ON_UPDATE_COMMAND_UI(ID_FILE_OUVRIR, OnUpdateFileOuvrir)
	ON_COMMAND(ID_FILE_OUVRIR, OnFileOuvrir)
	ON_UPDATE_COMMAND_UI(ID_GENERATION_MIRE, OnUpdateGenerationMire)
	ON_COMMAND(ID_GENERATION_MIRE, OnGenerationMire)
	ON_COMMAND(ID_IMAGE_NEGATIF, OnImageNegatif)
	ON_COMMAND(ID_FILTRAGE_MORPHOLOGIQUE, OnFiltrageMorphologique)
	ON_UPDATE_COMMAND_UI(ID_FILTRAGE_MORPHOLOGIQUE, OnUpdateFiltrageMorphologique)
	ON_UPDATE_COMMAND_UI(ID_FILTRES, OnUpdateFiltres)
	ON_UPDATE_COMMAND_UI(ID_SEUILLAGE, OnUpdateSeuillage)
	ON_COMMAND(ID_SEUILLAGE, OnSeuillage)
	ON_COMMAND(ID_PLATINE_ROT, OnPlatineRot)
	ON_UPDATE_COMMAND_UI(ID_PLATINE_ROT, OnUpdatePlatineRot)
	ON_COMMAND(ID_PARAMETRES_MONTAGE, OnParametresMontage)
	ON_COMMAND(ID_ACQUISITION, OnAcquisition)
	//}}AFX_MSG_MAP
	//Coordonnes dfilantes de la souris
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdateCoordonnees)
	//N de la fentre courante
	ON_UPDATE_COMMAND_UI(ID_BK1, OnUpdateNoFen)
	//Units
	ON_UPDATE_COMMAND_UI(ID_BK2, OnUpdateUnites)
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           //Status line indicator
	ID_BK1,									//N de la fentre active
	ID_BK,									//Coordonnes dfilantes de la souris
	ID_BK2,									//Units
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
///////////////////////////////////////////////////
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	m_pApp=((CBkApp*)AfxGetApp());
}
//_________________________________________________
CMainFrame::~CMainFrame()
{
}
//_________________________________________________
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//Ouverture plein cran
	ShowWindow(SW_SHOWMAXIMIZED);

	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}
//_________________________________________________
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}
///////////////////////////////////////////////////
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}
//_________________________________________________
void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}
#endif //_DEBUG
///////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnUpdateUnites(CCmdUI *pCmdUI)
{
	class CBkDoc* pDoc;
	short i,j;
	CString 
		r,l,
		s1="",s="";
	pDoc=m_pApp->GetDocument();
	m_wndStatusBar.SetPaneInfo(3,ID_BK2,SBPS_NORMAL,250);		
	if (pDoc!=NULL)
	{
		if (pDoc->m_OKXY)
			s.Format("X,Y(mm)*%1.0e",1/pDoc->m_fFactXY);
		else
			s.Format("X,Y(pixel)");
		
		//Suppression des 0 de X,Y(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s.GetLength()-2;
			if (s.GetAt(i)=='0')
			{
				r=s.Right(1);
				l=s.Left(i-1);
				s=l+r;
			}
		}
		if (pDoc->m_iNbB==8)
		{
			if (pDoc->m_OKZ)
				s1.Format("%s, Z(mm)*%1.0e",s,1/pDoc->m_fFactZ);
			else
				s1.Format("%s, W(luminance)",s);
		}
		else
		{
			if (pDoc->m_OKZ)
				s1.Format("%s, ZR(mm)*%1.0e",s,1/pDoc->m_fFactZ);
			else
				s1.Format("%s, RVB(luminance)",s);
		}
		//Suppression des 0 de Z(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s1.GetLength()-2;
			if (s1.GetAt(i)=='0')
			{
				r=s1.Right(1);
				l=s1.Left(i-1);
				s1=l+r;
			}
		}
	}
	pCmdUI->SetText(s1); 
}
//_________________________________________________
void CMainFrame::OnUpdateCoordonnees(CCmdUI *pCmdUI)
{
	CString 
		str="",s,s1,s2,s3,s4;
	short x,y;
	float xmm,ymm,zmm;
	long w;
	class CBkDoc* pDoc;
	pDoc=m_pApp->GetDocument();
	m_wndStatusBar.SetPaneInfo(2,ID_BK,SBPS_NORMAL,300);		
	if (pDoc!=NULL)
	{
		if (m_pApp->GrabIsStarted)
		{
			str="Acquisition permanente..."; 
		}
		else
		{
			x=pDoc->m_iX-pDoc->m_iDx;
			y=pDoc->m_iY-pDoc->m_iDy;
			if (pDoc->m_iNbB==8)
			{
				//Image en 8 bits
				w=pDoc->m_iW-pDoc->m_iDw;
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("X:%1.3f",xmm);
						s1.Format("Y:%1.3f",ymm);
					}
					else
					{
						//Pixel
						s.Format("X:%d",x);
						s1.Format("Y:%d",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("Z:%1.3f",zmm);
					}
					else
					{
						//Luminance
						s2.Format("W:%d",w);
					}
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f",xmm);
						s1.Format("dY:%1.3f",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d",x);
						s1.Format("dY:%d",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("dZ:%1.3f",zmm);
					}
					else
					{
						//Luminance
						s2.Format("dW:%d",w);
					}
				}
				str.Format("%s, %s, %s",s,s1,s2);
			}
			else
			if (pDoc->m_iNbB==24)
			{
				//Image en 24 bits
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					w=pDoc->m_iW-pDoc->m_iDw;
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("X:%d,",x);
						s1.Format("Y:%d,",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*(w&255)*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("ZR:%1.3f",zmm);
						s3=s4="";
					}
					else
					{
						//luminance
						s2.Format("R:%d,",w&255); 
						s3.Format("V:%d,",(w/256)&255); 
						s4.Format("B:%d",(w/65536)&255);
					}
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d,",x);
						s1.Format("dY:%d,",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						w=(pDoc->m_iW&255)-(pDoc->m_iDw&255);
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("dZR:%1.3f",zmm);
						s3=s4="";
					}
					else
					{
						//luminance
						w=(pDoc->m_iW&255)-(pDoc->m_iDw&255);
						s2.Format("dR:%d,",w);
						w=((pDoc->m_iW/256)&255)-((pDoc->m_iDw/256)&255);
						s3.Format("dV:%d,",w); 
						w=((pDoc->m_iW/65536)&255)-((pDoc->m_iDw/65536)&255);
						s4.Format("dB:%d",w);
					}
				}
				str.Format("%s %s %s %s %s",s,s1,s2,s3,s4);
			}		 
		}
	}
	else
	{
		str="";
	}
	pCmdUI->SetText(str);
}
//_________________________________________________
void CMainFrame::OnUpdateNoFen(CCmdUI *pCmdUI)
{
	class CBkDoc* pDoc;
	pDoc=m_pApp->GetDocument();
	CString s="";
	if (pDoc!=NULL)
	{
		m_wndStatusBar.SetPaneInfo(1,ID_BK1,SBPS_NORMAL,30);		
		s.Format("(%d)",pDoc->m_iNo); 
	}
	pCmdUI->SetText(s); 
}
//________________________________________
void CMainFrame::OnUpdateFileOuvrir(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFileOuvrir() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	if (m_pApp->m_iNb<m_pApp->m_iNbMax)
	{
		SendMessage(WM_COMMAND,ID_FILE_OPEN,0);
	}
}
//________________________________________
void CMainFrame::OnUpdateFileNouveau(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFileNouveau() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	if (m_pApp->m_iNb<m_pApp->m_iNbMax)
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	}
}
//_________________________________________________
void CMainFrame::OnUpdateProfils(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pProfilDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnProfils() 
{
	//Trac de profil(s) dans l'image
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (m_pApp->m_pProfilDlg==NULL) 
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pProfilDlg=new CProfilDlg(this);
	}
}
//_________________________________________________
void CMainFrame::OnUpdateMasque(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pMasqueDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnMasque() 
{
	if (m_pApp->m_pMasqueDlg==NULL) 
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pMasqueDlg=new CMasqueDlg(this);
	}
}
//_________________________________________________
void CMainFrame::OnCalibrer() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CCalbDlg d;
	d.DoModal();
}
//_________________________________________________
void CMainFrame::OnUpdateCoter(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pCoteDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnCoter() 
{
	if (m_pApp->m_pCoteDlg==NULL)
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pCoteDlg=new CCoteDlg(this);
	}
}
//_________________________________________________
void CMainFrame::OnCouleurs() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CCoulDlg d;
	d.DoModal();	
}
//_________________________________________________
void CMainFrame::OnUpdateZoomImage(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pZoomDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnZoomImage() 
{
	if (m_pApp->m_pZoomDlg==NULL)	
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pZoomDlg=new CZoomDlg(this);
	}
}
//_________________________________________________
void CMainFrame::OnFft2d() 
{
	CFftDlg d;
	d.DoModal();	
}
//_________________________________________________
void CMainFrame::OnAjusterParametres() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CAjustDlg d;
	d.DoModal();	
}
//_________________________________________________
void CMainFrame::OnMulCte() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CMathDlg d;
	d.DoModal();	
}
//_________________________________________________
void CMainFrame::OnEditCopy() 
{
	//Copier
	unsigned char huge *dib;
	short 
		rcode,no;
	HGLOBAL hMem;
	class CBkDoc* pDoc=m_pApp->GetDocument();
	if (m_pApp->GrabIsStarted) pDoc->FigerAcq();
	//N image  copier
	no=m_pApp->m_iNo_A_Copier=pDoc->m_iNo;

	rcode=m_pApp->DupliquerImageDestTempo(no,no);
	if (rcode==0) windowtoimage(pDoc->m_pView->m_hWnd,m_pApp->imt[no]);//Pointer la vue, sinon l'cran est copi...
	//Copier aussi dans le presse-papier Windows
	if (OpenClipboard())
	{
		EmptyClipboard();
		rcode=imagetodib(m_pApp->imt[no],&dib);
		if (rcode==0)
		{
			hMem=(HGLOBAL)GlobalHandle(dib);	//Sous V4.0
			GlobalUnlock(hMem);
			SetClipboardData(CF_DIB,hMem);
			CloseClipboard();	
		}		
	}
}
//_________________________________________________
void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNo_A_Copier==-1)	pCmdUI->Enable(FALSE);
}
//_________________________________________________
void CMainFrame::OnEditPaste() 
{
	//Coller
	class CBkDoc 
		*pDoc=m_pApp->GetDocument(),
		*pDocCopier=m_pApp->GetDocument(m_pApp->m_iNo_A_Copier);
	
	short m_iNo=pDoc->m_iNo; 
	
	if (pDocCopier!=NULL )
	{
		if (m_pApp->GrabIsStarted) pDoc->FigerAcq();
		m_pApp->DupliquerImageDest(m_pApp->m_iNo_A_Copier,m_iNo);
		//Transmettre le facteur d'chelle
		pDoc->m_fEchXY=pDocCopier->m_fEchXY;
	}
	//Raffichage vue
	pDoc->UpdateAllViews(NULL);
}
//_________________________________________________
void CMainFrame::OnCollerlepressepapier() 
{
	//Coller en provenance du presse-papier Windows
	unsigned char huge *dib;
	short 
		rcode;
	HGLOBAL hMem;
	CBkDoc *pDoc=m_pApp->GetDocument();
	short l,h,n;
	if (OpenClipboard())
	{
		if (m_pApp->GrabIsStarted) pDoc->FigerAcq();
		if ((hMem=GetClipboardData(CF_DIB))!=0)
		{
			dib=(unsigned char huge *)GlobalLock(hMem);
			dibtoimage(dib,pDoc->image);
			GlobalUnlock(hMem);
		}
		CloseClipboard();	
		l=pDoc->image->endx-pDoc->image->stx+1;
		h=pDoc->image->endy-pDoc->image->sty+1;
		pDoc->m_iL=l;
		pDoc->m_iH=h;
		pDoc->m_iNbB=pDoc->image->bmh->biBitCount;

		//Paramtrer la fentre destination
		pDoc->DimensionnerFenetre(l,h);
		pDoc->m_pView->SetScrollSizes(MM_TEXT, CSize(pDoc->m_iL,pDoc->m_iH));
		pDoc->m_pView->ScrollToPosition(CPoint(0,0));
		pDoc->m_iXpos=pDoc->m_pView->GetScrollPos(SB_HORZ);
		pDoc->m_iYpos=pDoc->m_pView->GetScrollPos(SB_VERT);
		pDoc->m_iType=0;
	}
}
//_________________________________________
void CMainFrame::OnOpMathLog() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CLogDlg d;
	d.DoModal();	
}
//_________________________________________________
void CMainFrame::OnDemodulImPhas() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CDemodDlg d;
	d.DoModal();	
}
//_________________________________________
void CMainFrame::OnUpdateViisuPseudo(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_OKCarte==FALSE)	pCmdUI->Enable(FALSE);
}
//_________________________________________
void CMainFrame::OnViisuPseudo() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CPseuDlg d;
	d.DoModal();	
}
//_________________________________________
void CMainFrame::OnUpdateAcqFig(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKCarte || m_pApp->GrabIsStarted==FALSE || m_pApp->m_iNb==0) pCmdUI->Enable(FALSE);
}
//_________________________________________
void CMainFrame::OnAcqFig() 
{
	m_pApp->GetDocument()->FigerAcq();
}
//_________________________________________
void CMainFrame::OnUpdateAcqPerm(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKCarte || m_pApp->GrabIsStarted==TRUE || m_pApp->m_iNb==0) pCmdUI->Enable(FALSE);
}
//_________________________________________
void CMainFrame::OnAcqPerm() 
{
	m_pApp->GetDocument()->AcqPerm();
}
//________________________________________
void CMainFrame::OnUpdateTempsReel(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_OKCarte==FALSE)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnTempsReel() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CTemReDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateCalculImPhase4(CCmdUI* pCmdUI) 
{
	//Il faut au moins 4 fentres ouvertes
	if (m_pApp->m_iNb<4) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCalculImPhase4() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CPhas4Dlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnUpdateDepManuMot(CCmdUI* pCmdUI) 
{
  int dwGetVer=GetVersion();
  if (!(dwGetVer & 0x80000000))
  {
    //Windows NT is loaded
		pCmdUI->Enable(FALSE);
	}
}
//________________________________________
void CMainFrame::OnDepManuMot() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CDepMaDlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnPilotageDephStein() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CPiezoDlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnUpdateAxeSortieSurcourse(CCmdUI* pCmdUI) 
{
  int dwGetVer=GetVersion();
  if (!(dwGetVer & 0x80000000))
  {
    //Windows NT is loaded
		pCmdUI->Enable(FALSE);
	}
}
//________________________________________
void CMainFrame::OnAxeSortieSurcourse() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CSurcoDlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnAcqImPhas4() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CAcqPhDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateFiltres(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pFiltreDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFiltres() 
{
	if (m_pApp->m_pFiltreDlg==NULL)	
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pFiltreDlg=new CFiltreDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateFiltrageMorphologique(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pMorphoDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFiltrageMorphologique() 
{
	if (m_pApp->m_pMorphoDlg==NULL)	
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pMorphoDlg=new CMorphoDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateSeuillage(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CMainFrame::OnSeuillage() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CSeuilDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateExtraction(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pExtractDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnExtraction() 
{
	if (m_pApp->m_pExtractDlg==NULL) 
	{
		if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
		m_pApp->m_pExtractDlg=new CExtractDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateConversionPseudo(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=m_pApp->GetDocument();
	short nbB=pDoc->image->bmh->biBitCount;
	if (nbB==24) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnConversionPseudo() 
{
	short i,j;
	unsigned char wR,wV,wB;
	long w;
	class CBkDoc* pDoc=m_pApp->GetDocument();
	
	m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,0);

	freeimage(pDoc->image);
	pDoc->m_iNbB=24;
	allocimage(pDoc->image,pDoc->m_iL,pDoc->m_iH,pDoc->m_iNbB);
	for (i=0;i<pDoc->m_iL;i++)
	{
		for (j=0;j<pDoc->m_iH;j++)
		{
			w=getpixelcolor(m_pApp->imt[0],i,j);
			m_pApp->PseudoCoul(w,&wR,&wV,&wB);
			w=(long)wR+256*wV+65536*wB;
			setpixelcolor(pDoc->image,i,j,w);
		}
	}
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CMainFrame::OnUpdateConversionNg(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=m_pApp->GetDocument();
	short nbB=pDoc->image->bmh->biBitCount;
	if (nbB==8) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnConversionNg() 
{
	class CBkDoc* pDoc=m_pApp->GetDocument();
	m_pApp->DupliquerImageDestTempo(pDoc->m_iNo,1);
	freeimage(pDoc->image);
	pDoc->m_iNbB=8;
	allocimage(pDoc->image,pDoc->m_iL,pDoc->m_iH,pDoc->m_iNbB);
	colortogray(m_pApp->imt[1],pDoc->image);
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CMainFrame::OnUpdateGenerationMire(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CMainFrame::OnGenerationMire() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	CMireDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnImageNegatif() 
{
	if (m_pApp->GrabIsStarted) m_pApp->GetDocument()->FigerAcq();
	class CBkDoc* pDoc=m_pApp->GetDocument();
	negative(pDoc->image,pDoc->image);	
	pDoc->UpdateAllViews(NULL);
}
//Visualisation 3D________________________
void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CMDIFrameWnd::OnPaletteChanged(pFocusWnd);
	if(pFocusWnd != this)	OnQueryNewPalette();
	//AfxMessageBox("ici");//On n'y vient pas....
}
//________________________________________
BOOL CMainFrame::OnQueryNewPalette() 
{
	WORD i;
	CPalette *pOldPal;
	CBkView	*pView=(CBkView *)GetActiveView();
	CClientDC	dc(pView);
	pOldPal=dc.SelectPalette(&pView->m_cPalette, FALSE);
	i=dc.RealizePalette();
	dc.SelectPalette(pOldPal,FALSE);
	if(i>0)	InvalidateRect(NULL);
	//AfxMessageBox("ici");//On n'y vient pas....
	return CFrameWnd::OnQueryNewPalette();
}
//Pour Schwartz Yann______________________
void CMainFrame::OnPlatineRot() 
{
	CDepRoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdatePlatineRot(CCmdUI* pCmdUI) 
{
  if (!(GetVersion() & 0x80000000))
  {
    //Windows NT, 2000, XP prsent
		pCmdUI->Enable(FALSE);
	}
}
//________________________________________
void CMainFrame::OnParametresMontage() 
{
	CParaMoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnAcquisition() 
{
	CDigiDlg d;
	d.DoModal();
}
