// MainFrm.h : interface of the CMainFrame class
//
///////////////////////////////////////////////////
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
protected:
	class CBkApp* m_pApp;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateCoordonnees(CCmdUI *pCmdUI);
	afx_msg void OnUpdateUnites(CCmdUI *pCmdUI);
	afx_msg void OnUpdateNoFen(CCmdUI *pCmdUI);
	afx_msg void OnProfils();
	afx_msg void OnUpdateProfils(CCmdUI* pCmdUI);
	afx_msg void OnCalibrer();
	afx_msg void OnCoter();
	afx_msg void OnUpdateCoter(CCmdUI* pCmdUI);
	afx_msg void OnCouleurs();
	afx_msg void OnZoomImage();
	afx_msg void OnUpdateZoomImage(CCmdUI* pCmdUI);
	afx_msg void OnFft2d();
	afx_msg void OnAjusterParametres();
	afx_msg void OnMulCte();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnCollerlepressepapier();
	afx_msg void OnDemodulImPhas();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnUpdateMasque(CCmdUI* pCmdUI);
	afx_msg void OnMasque();
	afx_msg void OnOpMathLog();
	afx_msg void OnUpdateAcqFig(CCmdUI* pCmdUI);
	afx_msg void OnAcqFig();
	afx_msg void OnUpdateAcqPerm(CCmdUI* pCmdUI);
	afx_msg void OnAcqPerm();
	afx_msg void OnViisuPseudo();
	afx_msg void OnUpdateViisuPseudo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTempsReel(CCmdUI* pCmdUI);
	afx_msg void OnTempsReel();
	afx_msg void OnCalculImPhase4();
	afx_msg void OnDepManuMot();
	afx_msg void OnPilotageDephStein();
	afx_msg void OnAxeSortieSurcourse();
	afx_msg void OnUpdateCalculImPhase4(CCmdUI* pCmdUI);
	afx_msg void OnAcqImPhas4();
	afx_msg void OnFiltres();
	afx_msg void OnUpdateAxeSortieSurcourse(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDepManuMot(CCmdUI* pCmdUI);
	afx_msg void OnExtraction();
	afx_msg void OnUpdateExtraction(CCmdUI* pCmdUI);
	afx_msg void OnUpdateConversionPseudo(CCmdUI* pCmdUI);
	afx_msg void OnConversionPseudo();
	afx_msg void OnUpdateConversionNg(CCmdUI* pCmdUI);
	afx_msg void OnConversionNg();
	afx_msg void OnUpdateFileNouveau(CCmdUI* pCmdUI);
	afx_msg void OnFileNouveau();
	afx_msg void OnUpdateFileOuvrir(CCmdUI* pCmdUI);
	afx_msg void OnFileOuvrir();
	afx_msg void OnUpdateGenerationMire(CCmdUI* pCmdUI);
	afx_msg void OnGenerationMire();
	afx_msg void OnImageNegatif();
	afx_msg void OnFiltrageMorphologique();
	afx_msg void OnUpdateFiltrageMorphologique(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltres(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSeuillage(CCmdUI* pCmdUI);
	afx_msg void OnSeuillage();
	afx_msg void OnPlatineRot();
	afx_msg void OnUpdatePlatineRot(CCmdUI* pCmdUI);
	afx_msg void OnParametresMontage();
	afx_msg void OnAcquisition();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
///////////////////////////////////////////////////
