// Phas4Dlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "Phas4Dlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CPhas4Dlg dialog
CPhas4Dlg::CPhas4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPhas4Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPhas4Dlg)
	m_sTexte = _T("");
	m_OKFiltre = FALSE;
	//}}AFX_DATA_INIT
}
void CPhas4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPhas4Dlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_SOURCE3, m_comboSource3);
	DDX_Control(pDX, IDC_SOURCE4, m_comboSource4);
	DDX_Control(pDX, IDC_SOURCE2, m_comboSource2);
	DDX_Control(pDX, IDC_SOURCE1, m_comboSource1);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Check(pDX, IDC_FILTRE, m_OKFiltre);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPhas4Dlg, CDialog)
	//{{AFX_MSG_MAP(CPhas4Dlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CPhas4Dlg message handlers
BOOL CPhas4Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short n,i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	m_iI=new short[m_pApp->m_iNbMax];
	//Initialisation tableau N images
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		m_iI[i]=-1;
	}                 
	j=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)!=NULL)
		{
			s.Format("Image %d",i);	
			m_comboDest.AddString(s);
			m_comboSource1.AddString(s);
			m_comboSource2.AddString(s);
			m_comboSource3.AddString(s);
			m_comboSource4.AddString(s);
			m_iI[j]=i;
			j++;
		}         
	}
	m_OK=FALSE;
	m_btnOK.EnableWindow(FALSE);
	m_OKFiltre=TRUE;
	if (j>=4)
	{
		SetTimer(1,200,NULL);
	}
	else
	{
		m_sTexte="Il faut 4 images diffrentes !";
	}
	//Contrle du bouton OK par timer
	//Recherche N nouvelle image destination
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->GetDocument(i)==NULL)
		{
			s.Format("IMAGE %d",i);	
			m_comboDest.AddString(s);
			//Image destination
			m_iI[j]=i;
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	i=m_comboSource1.GetCount()-4;if (i<0) i=0;
	m_comboSource1.GetLBText(i,s);
	m_comboSource1.SetWindowText(s);	
	i=m_comboSource2.GetCount()-3;if (i<0) i=0;
	m_comboSource2.GetLBText(i,s);
	m_comboSource2.SetWindowText(s);	
	//Par dfaut sur avant-dernire image
	i=m_comboSource3.GetCount()-2;if (i<0) i=0;
	m_comboSource3.GetLBText(i,s);
	m_comboSource3.SetWindowText(s);	
	//Par dfaut sur dernire image
	i=m_comboSource4.GetCount()-1;if (i<0) i=0;
	m_comboSource4.GetLBText(i,s);
	m_comboSource4.SetWindowText(s);
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CPhas4Dlg::OnCancel() 
{
	KillTimer(1);
	delete m_iI;
	CDialog::OnCancel();
}
//________________________________________
void CPhas4Dlg::OnOK() 
{
	int rcode=0;
	short i,j,is1,is2,is3,is4,id;
	long w,w1,w2,w3,w4;
	CBkDoc *ps1,*ps2,*ps3,*ps4,*pd;
	KillTimer(1);
	UpdateData(TRUE);
	//Si l'utilisateur n'a pas touch aux combos...
	if (m_comboSource1.GetCurSel()<0)
		is1=m_iI[m_comboSource1.GetCount()-4];
	else
		is1=m_iI[m_comboSource1.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		is2=m_iI[m_comboSource2.GetCount()-3];
	else
		is2=m_iI[m_comboSource2.GetCurSel()];
	if (m_comboSource3.GetCurSel()<0)
		is3=m_iI[m_comboSource3.GetCount()-2];
	else
		is3=m_iI[m_comboSource3.GetCurSel()];
	if (m_comboSource4.GetCurSel()<0) 
		is4=m_iI[m_comboSource4.GetCount()-1];
	else
		is4=m_iI[m_comboSource4.GetCurSel()];
	if (m_comboDest.GetCurSel()<0) 
		id=m_iI[m_comboDest.GetCount()-1];
	else
		id=m_iI[m_comboDest.GetCurSel()];

	ps1=m_pApp->m_pDocument[is1];
	ps2=m_pApp->m_pDocument[is2];
	ps3=m_pApp->m_pDocument[is3];
	ps4=m_pApp->m_pDocument[is4];

	//CString z;
	//z.Format("Im_0:%d,Im1_pi/2:%d,Im_pi:%d,Im_3pi/2:%d",is1,is2,is3,is4);AfxMessageBox(z);
	
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pApp->GetDocument(id)==NULL)
	{
		//L'image destination existe maintenant.
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		//Pointeur sur destination
		pd=m_pApp->m_pDocument[id];
	}
	else
	{
		//Pointeur sur destination
		pd=m_pApp->m_pDocument[id];
	}

	short
		l,h,nbB,
		l1,h1,nbB1,
		l2,h2,nbB2;

	l=ps1->image->endx-ps1->image->stx+1;
	h=ps1->image->endy-ps1->image->sty+1;
	nbB=ps1->image->bmh->biBitCount;
	l1=pd->image->endx-pd->image->stx+1;
	h1=pd->image->endy-pd->image->sty+1;
	nbB1=pd->image->bmh->biBitCount;
	if (nbB!=nbB1 || h!=h1 || l!=l1)
	{
		//Image destination de la taille image source
		freeimage(pd->image);
		rcode=allocimage(pd->image,l,h,nbB);
	}
	if (rcode!=0) AfxMessageBox("(1) Erreur dans fonction CPhas4Dlg::OnOK");

	pd->m_iL=l;pd->m_iH=h;pd->m_iNbB=nbB;
	pd->m_sNomFic.Format("ImPhase");
	pd->DimensionnerFenetre(l,h);
	pd->DefinirCurseurs(l,h);
	pd->m_iType=0;
	pd->InitTracker();//Pas de tracker sur la destination...

	//Image temporaire
	l2=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
	h2=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
	nbB2=m_pApp->imt[0]->bmh->biBitCount;
	if (l!=l2 || h!=h2 || nbB!=nbB2)
	{
		freeimage(m_pApp->imt[0]);
		rcode=allocimage(m_pApp->imt[0],l,h,nbB);
	}
	if (rcode!=0) AfxMessageBox("(2) Erreur dans fonction CPhas4Dlg::OnOK");
	//Calcul de l'image phase entre [0 et 255]
	float r;
	if (m_OKFiltre)
	{
		//On calcule la moyenne au numrateur et au dnominateur des pixels d'une zone 3x3
		short id,ia,jd,ja,l,h,n;
		for (i=0;i<pd->m_iL;i++)
		{
			for (j=0;j<pd->m_iH;j++)
			{
				id=i-1;if (id<0) id=0;
				ia=i+1;if (ia>=pd->m_iL) ia=pd->m_iL-1;
				jd=j-1;if (jd<0) jd=0;
				ja=j+1;if (ja>=pd->m_iH) ja=pd->m_iH-1;
				w1=0;w4=0;n=0;
				for (l=id;l<=ia;l++)
				{
					for (h=jd;h<=ja;h++)
					{
						w4=w4+getpixelcolor(ps4->image,l,h)-getpixelcolor(ps2->image,l,h);
						w1=w1+getpixelcolor(ps1->image,l,h)-getpixelcolor(ps3->image,l,h);
						n++;
					}
				}
				if (n!=0)
				{
					w4=w4/n;w1=w1/n;
				}
				else
				{
					w4=0;w1=0;
				}

				if(w1==0)
					r=0;
				else
					//r=atan2(1.0*(w4),1.0*(w1));
					r=atan_bk_f(1.0*(w4),1.0*(w1));
				//Intervalle [0, 255]
				//r=255.0*(r+3.14)/6.28;
				r=255.0*r/6.28;
				if (r<0) r=0;
				if (r>255) r=255;
				w=(long)(r);
				setpixelcolor(m_pApp->imt[0],i,j,w);
			}
		}		
	}
	else
	{
		for (i=0;i<ps1->m_iL;i++)
		{
			for (j=0;j<ps1->m_iH;j++)
			{
				w1=getpixelcolor(ps1->image,i,j);
				w2=getpixelcolor(ps2->image,i,j);
				w3=getpixelcolor(ps3->image,i,j);
				w4=getpixelcolor(ps4->image,i,j);
				if(w1-w3==0)
				{
					r=0;
				}
				else
				{
					//r=atan2(1.0*(w4-w2),1.0*(w1-w3));
					r=atan_bk_f(1.0*(w4-w2),1.0*(w1-w3));
				}
				//Intervalle [0, 255]
				//r=255.0*(r+3.14)/6.28;
				r=255.0*r/6.28;
				if (r<0) r=0;
				if (r>255) r=255;
				w=(long)(r);
				setpixelcolor(m_pApp->imt[0],i,j,w);
			}
		}
	}
	delete m_iI;
	rcode=copyimage(m_pApp->imt[0],pd->image);
	if (rcode!=0) AfxMessageBox("(3) Erreur dans fonction CPhas4Dlg::OnOK");
	pd->PositionnerFenetre(0,0);
	CDialog::OnOK();
}
//__________________________________________________
void CPhas4Dlg::OnTimer(UINT nIDEvent) 
{
	//Validation du bouton OK si 4 images diffrentes slectionnes
	short is1,is2,is3,is4,id;
	UpdateData(TRUE);
	BOOL ok=FALSE;

	//Si l'utilisateur n'a pas touch aux combos...
	if (m_comboSource1.GetCurSel()<0)
		is1=m_iI[m_comboSource1.GetCount()-4];
	else
		is1=m_iI[m_comboSource1.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		is2=m_iI[m_comboSource2.GetCount()-3];
	else
		is2=m_iI[m_comboSource2.GetCurSel()];
	if (m_comboSource3.GetCurSel()<0)
		is3=m_iI[m_comboSource3.GetCount()-2];
	else
		is3=m_iI[m_comboSource3.GetCurSel()];
	if (m_comboSource4.GetCurSel()<0) 
		is4=m_iI[m_comboSource4.GetCount()-1];
	else
		is4=m_iI[m_comboSource4.GetCurSel()];
	if (m_comboDest.GetCurSel()<0) 
		id=m_iI[m_comboDest.GetCount()-1];
	else
		id=m_iI[m_comboDest.GetCurSel()];
	
	if (is1!=is2 && is1!=is3 && is1!=is4) 
	{
		if (is2!=is1 && is2!=is3 && is2!=is4) 
		{
			if (is3!=is1 && is3!=is2 && is3!=is4) 
			{
					if (is4!=is1 && is4!=is2 && is4!=is3) 
					{
						ok=TRUE;
					}
			}
		}
	}
	if (ok!=m_OK)
	{
		m_OK=!m_OK;
		m_btnOK.EnableWindow(m_OK);
	}

	//m_sTexte.Format ("%d = (%d-%d)/(%d- %d)",id,is4,is2,is1,is3);
	if (!ok) m_sTexte="Les 4 images ne sont pas diffrentes!"; else m_sTexte=""; 
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
float CPhas4Dlg::atan_bk_f(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}

		}
	}
	return r;
}
