// SurcoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "SurcoDlg.h"
//#include "BkDoc.h"
#include "C832.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
///////////////////////////////////////////
// CSurcoDlg dialog
CSurcoDlg::CSurcoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSurcoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSurcoDlg)
	m_s = _T("");
	m_s1 = _T("");
	m_s2 = _T("");
	//}}AFX_DATA_INIT
}
void CSurcoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSurcoDlg)
	DDX_Control(pDX, IDXP, m_btnXp);
	DDX_Control(pDX, IDXM, m_btnXm);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_STATIC_TEXTE2, m_s1);
	DDX_Text(pDX, IDC_STATIC_TEXTE3, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSurcoDlg, CDialog)
	//{{AFX_MSG_MAP(CSurcoDlg)
	ON_BN_CLICKED(IDXM, OnXm)
	ON_BN_CLICKED(IDXP, OnXp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CSurcoDlg message handlers
void CSurcoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CSurcoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	//m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_pC832=new CC832(120000);          

	if (!m_pC832->OK(1))
	{
		m_pC832->RT(1);
		m_pC832->IT(1);
	}	
	//La carte n'a toujours pas t trouve...
	if (!m_pC832->OK(1))
	{
		m_s="Carte P.I. C832 non trouve !";
		m_btnXm.EnableWindow(FALSE);
		m_btnXp.EnableWindow(FALSE);
	} 
	else
	{
		if (m_pC832->BT(1))
		{
			m_btnXm.EnableWindow(TRUE);
			m_btnXp.EnableWindow(TRUE);
			m_pC832->RT(1);
			m_pC832->IT(1);
			m_pC832->SV(1,10);
			m_s="Surcourse dtecte !";
			m_s1="Par appui sur X+ ou X-, dpl. = 0.2 mm";
			m_s2="Ne vous trompez pas de sens !!";
		}
		else
		{
			m_s="Pas de surcourse dtecte !";
			m_btnXm.EnableWindow(FALSE);
			m_btnXp.EnableWindow(FALSE);
		}


  }
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CSurcoDlg::OnXm() 
{
	float x;
	x=m_pC832->TP(1);
	m_s1.Format("X(mm):%1.2f",x);
	m_s2="";
	UpdateData(FALSE);
	m_pC832->MR(1,-0.2);	
	while (!m_pC832->MD(1))
	{
		//Attente fin mouvement
	}
	x=m_pC832->TP(1);
	m_s1.Format("X(mm):%1.2f",x);
	if (m_pC832->BT(1))
	{
			m_s="Surcourse dtecte !";
	}
	else
	{
		m_s="Fin de surcourse !";
		m_btnXm.EnableWindow(FALSE);
		m_btnXp.EnableWindow(FALSE);
	}
	UpdateData(FALSE);
}
//__________________________________________________
void CSurcoDlg::OnXp() 
{
	float x;
	x=m_pC832->TP(1);
	m_s1.Format("X(mm):%1.2f",x);
	m_s2="";
	UpdateData(FALSE);
	m_pC832->MR(1,0.2);
	while (!m_pC832->MD(1))
	{
		//Attente fin mouvement
	}
	x=m_pC832->TP(1);
	m_s1.Format("X(mm):%1.2f",x);
	if (m_pC832->BT(1))
	{
			m_s="Surcourse dtecte !";
	}
	else
	{
		m_s="Fin de surcourse !";
		m_btnXm.EnableWindow(FALSE);
		m_btnXp.EnableWindow(FALSE);
	}
	UpdateData(FALSE);
	
}
//__________________________________________________
void CSurcoDlg::OnCancel() 
{
	delete m_pC832;	
	CDialog::OnCancel();
}
